<?
  /* File:    etc/config.php: configuration options
   * Type:    CMS config file
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    - move most settings off to db-based string bundles
   * Changes: -
   */

  // ***************************************************************************
  // customization area
  // ***************************************************************************

  @ini_set('error_reporting', 'E_ALL');
  @ini_set('session.cache_expire', 12*60);
  @ini_set("include_path", ".:../");
  header('content-type: text/html;charset=utf-8');

  $config = array(

    'site' => array(
      'dateformat' => 'd.m.Y',
      'timeformat' => 'H:i:s',
      'defaultnode' => '1',
      'defaultpagetemplate' => 'default.php',
      'defaultlanguage' => 'en',
      'loginnotify' => '',
      'democite' => false,

      'urlrewrite' => true,
      'urlrewrite_method' => 'pathinfo', /* modrewrite, pathinfo */
      'urlrewrite_pathseparator' => '-',
      'urlrewrite_pathinfo_base' => 'cm.php',

      'urlrewrite_autoname' => true,
      'urlrewrite_autoname_base' => 'doc.php',

      'urlrewrite_showlanguage' => true,

      'dsid' => 1,
      'rootnode' => 1,

      'theme' => 'default',
      'compress' => true,
      ),

    'cms' => array(
      'defaultlanguage' => 'en',
      'defaultblocktype' => 'richtext',
      'sessioninstance' => 'cms2',
      'versioning' => false,
      'defaulttemplate' => 'default.manifest.php',
      ),

    );

  $config['site']['dsid'] = 1;

  // ***************************************************************************
  // database configuration
  // ***************************************************************************

  $dbConfigFile = 'etc/config.db.php';
  @include($dbConfigFile);

  // ***************************************************************************
  // include server-specific configuration file (if one exists)
  // ***************************************************************************
  $serverConfigFile = 'etc/server.'.$_SERVER['SERVER_NAME'].'.php';
  @include($serverConfigFile);

  $preFix = $config['db']['prefix'];

  // ***************************************************************************
  // init cms call
  // ***************************************************************************

  $request_id = md5(time().rand(1,10000));

  if (substr($_SERVER['PATH_INFO'],0,2)=='/;')
  {
    // alternative, search-engine-friendly parameters?
    CutSegment('/;', $_SERVER['PATH_INFO']);
    $urlParams = explode(';', $_SERVER['PATH_INFO']);
    if (is_array($urlParams))
      foreach ($urlParams as $paramItem)
      {
        $pkey = CutSegment('=', $paramItem);
        $_REQUEST[$pkey] = $paramItem;
      }
  }

  $inputReplace[] = urldecode('%E2%82%AC'); $inputSubstitute[] = '&euro;';

  // decode any input (it is assumed to be UTF-7) to native charset
  foreach ($_REQUEST as $k => $v)
    $_REQUEST[$k] = utf8_decode(str_replace($inputReplace, $inputSubstitute, $v));
    
  if (get_magic_quotes_gpc())
    foreach ($_REQUEST as $k => $v)
      $_REQUEST[$k] = stripslashes($v);
          
  getBasePath();

?>
