<?
  /* File:    interface/admin/adminmenu.php: creates the menu that sits on
   *          top of the admin frameset. Its content is determined by the
   *          $adminModules array locally and the optional $dynamicModules Array
   *          externally.
   * Type:    user interface
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    /
   * Changes: 06.04.2006, Marco - Added product link 
   */

  global $site; 
  
  $adminModules = array(
    array('id' => '?m=admin&i=startpage', 'i' => 'startpage', 'caption' => 'menu.startpage', 'ico' => 'ico_overview22'),
    array('id' => '?m=admin&i=content', 'i' => 'content', 'caption' => 'menu.content', 'ico' => 'ico_content22'),
    //array('id' => '?m=admin&i=resources', 'i' => 'resources', 'caption' => 'menu.resources', 'ico' => 'ico_resource22'),
    array('id' => '?m=admin&i=preview', 'i' => 'preview', 'caption' => 'menu.preview', 'ico' => 'ico_preview22'),
    array('id' => '?m=admin&i=statistics', 'i' => 'stats', 'caption' => 'menu.stats', 'ico' => 'ico_preview'),
    array('id' => '?m=admin&i=settings', 'i' => 'settings', 'caption' => 'menu.settings', 'ico' => 'ico_settings22'),
  );
  
  //Add shop options to menu
  //
  if ($site->config['site']['shop']['shop_products_key'] != '') 
  {
      $adminModules[] =  array('id' => '?m=admin&i=products', 'i' => 'products', 'caption' => 'menu.products', 'ico' => 'ico_products');
      $adminModules[] =  array('id' => '?m=admin&i=orders', 'i' => 'orders', 'caption' => 'menu.orders', 'ico' => 'ico_orders');
  }
      
  //Add counter to menu
  //
  if ($site->config['site']['counter']['counter_activate'] != '') 
      $adminModules[] =  array('id' => '?m=admin&i=statistics', 'i' => 'statistics', 'caption' => 'menu.statistics', 'ico' => 'ico_statistics');
    
  $adminModules[] = array('id' => 'space', 'i' => '', 'caption' => '', 'ico' => '');
    //array('id' => '?m=admin&i=help', 'i' => 'resources', 'caption' => 'menu.help', 'ico' => 'ico_help22'),
  $adminModules[] = array('id' => '?m=admin/logout', 'i' => '', 'caption' => 'menu.logout', 'ico' => 'ico_exit22');

      
  if (sizeof($dynamicModules)>0)
    foreach ($dynamicModules as $m)
      $admodules[] = $m;

  if (sizeof($adminModules)>0)
    foreach ($adminModules as $m)
      $admodules[] = $m;

  print('<table cellspacing="0" cellpadding="0" width="100%"><tr>');
  foreach ($admodules as $m)
  {
    $style = '';
    if ($currentModule == $m['i']) $style = 'adminbutton_active';
    if ($m['id'] == 'space')
      print('<td width="100%">&nbsp;</td>');
    else if ($m['id'] == 'custom')
      print('<td valign="middle">'.$m['html'].'</td>');
    else
      print('<td width="1%"><a class="adminbutton '.$style.'" style="color: black;"  target="'.$m['target'].'" href="'.$m['id'].'">
         <img src="interface/img/'.$m['ico'].'.png" border="0" align="absmiddle"/><br>
         '.i18n('mci.'.$m['caption']).'</a></td>');
  }
  print('</tr></table>');


?>
