<?
  /* File:    interface/admin/lists/show_list.php: displays a list of content nodes,
   *          supports creation of new nodes, as well as the deletion of existing ones.
   * Type:    user interface
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    /
   * Changes: - support for multiple sites
   */

  include_once('lib/contentnode.class.php');
  include_once('lib/cms.simplesqllist.class.php');
  include_once('lib/alertboxes.php');
  include('interface/admin/header.php');
  include_once('lib/cms.displaylist.php');

  print('<script src="interface/scripts/admin.js"></script>');
?>

<table height="100%" width="100%" cellspacing="0" cellpadding="0"><tr><td><?

  print('<script src="interface/scripts/admin.js"></script>');

  $instance = getDefault($_REQUEST['list'], $_SESSION['cms']['currentlist']);
  $_SESSION['cms']['currentlist'] = $instance;
  $node = $_REQUEST['node'];

  displayHeader(i18n('mci.editlist'));

  if ($_REQUEST['cmd'] == 'new')
  {
    $newPage = new ContentNode();
    $newPage->initNewNode($node);
    $newPage->nodeDS['p_ref_list'] = $instance;
    $newPage->nodeDS['p_ref_parent'] = 0;
    $_REQUEST['select1'] = $newPage->save();
  }
  else if ($_REQUEST['cmd'] == 'delete')
  {
    DB_RemoveDataset('pages', $_REQUEST['select1']);
  }
  else if ($_REQUEST['cmd'] == 'publish')
  {
    $pageNode = new ContentNode($_REQUEST['select1']);
    $pageNode->nodeDS['p_status'] = 'A';
    $pageNode->save();
  }
  else if ($_REQUEST['cmd'] == 'unpublish')
  {
    $pageNode = new ContentNode($_REQUEST['select1']);
    $pageNode->nodeDS['p_status'] = 'H';
    $pageNode->save();
  }

  function editButtonCallback($params, $key)
  {
    return('<input type="button" value="'.i18n('mci.edit').'" style="width: 80px;"
      onclick="location.href=\'?m=admin/lists/edit.listframe&select1='.$key.'\';"/>');
  }

  function deleteButtonCallback($params, $key)
  {
    return('
      <input type="button" value="'.i18n('mci.delete').'" style="width: 80px;"
        onclick="location.href=\''.addslashes(makeConfirmLink(
          selfUrl(array('select1' => $key, 'cmd' => 'delete')),
          i18n('mci.list.deletitemquery')
          )).'\';"/>
      ');
  }

  function displayStatus($params, $key, $value)
  {
    $result = '<span style="color: green">'.i18n('mci.status.public').'</span>';
    if ($value == 'H') $result = '<span style="color: red">'.i18n('mci.status.draft').'</span>';
    return($result);
  }

  unset($_REQUEST['cmd']);

  global $site;

  $listView = new SimpleSQLList();
  $listView->selectId = $_REQUEST['select1'];
  $listView->columns[] = array('content' => 'editButtonCallback', 'caption' => '&nbsp;', 'width' => '5%');
  $listView->columns[] = array('field' => 'p_status', 'content' => 'displayStatus', 'width' => '5%');
  $listView->columns[] = array('field' => 'p_stamp', 'width' => '10%');
  $listView->columns[] = array('field' => 'p_caption', 'default' => 'unnamed', 'width' => '50%');
  $listView->columns[] = array('field' => 'us_username');
  $listView->columns[] = array('content' => 'deleteButtonCallback', 'caption' => '&nbsp;', 'width' => '15%');
  $listView->prepare('pages',
    array(' p_ref_list="'.$instance.'" AND '.getTableName('pages').'.refSiteID="'.$site->siteID.'" '),
    array(' '.getTableName('users').' ON (p_ref_owner = us_key) ')
    );
  
  $listView->selectorString = '?m=admin/lists/edit.listframe&list='.$_REQUEST['list'];//selfUrl(array(), array('block'));
  $listView->makeButton(
    selfUrl().'&cmd=new',
    'mci.newentry', 'btn_plus16.png', 'width: 150px; position: absolute; right: 4px; top: 2px;');
  $listView->display();
  //print('</td></tr><tr height="24"><td>');

  print('</td></tr></table>');

  include('interface/admin/footer.php');

?>
