<?
  /* File:    interface/admin/screen_content/show_blocks.php: displays a list of blocks
   *          for the currently selected page
   * Type:    user interface
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:
   * Changes: - removed session parameter dependence in cms views
   */

  include_once('lib/contentnode.class.php');
  include('interface/admin/header.php');
  include_once('lib/cms.displaylist.php');
?>

<script src="interface/scripts/prototype.js" type="text/javascript"></script>
<script src="interface/scripts/effects2.js" type="text/javascript"></script>
<script src="interface/scripts/dragdrop.js" type="text/javascript"></script>
<script src="interface/scripts/rpc.js" type="text/javascript"></script>

<?

  $currentNodeNr = getDefault($_REQUEST['node'], 1);
  $currentPage = new ContentNode($currentNodeNr);
  
  if ($_REQUEST['block']=='*first*')
  {
    $_REQUEST['block'] = trim($currentPage->getFirstBlockId());
  }

  $blocknr = $_REQUEST['block'];
  $propertiesViewer = GetDefault($propertiesViewer, 'admin/screen_content/show_properties');

  if ($_REQUEST['cmd'] != '')
    include_once('interface/admin/screen_content/show_blocks.commands.php');

  if ($blocknr != '') $blockparam = '&block='.$blocknr; else $blockparam = '';

  print('<script src="interface/scripts/admin.js"></script>');
  if ($_REQUEST['nopropertiesupdate'] != 'true')
    print('<script>openFrame("frm_properties", "?m='.$propertiesViewer.'&node='.
      $currentNodeNr.'&lang='.$_REQUEST['lang'].
      $blockparam.'")</script>');
  unset($_REQUEST['nopropertiesupdate']);

  include($currentPage->getManifestFilename());

  displayHeader('<a href="?m=admin/screen_content/show_blocks&node='.$currentNodeNr.
        '"><span class="frameToolbarText">'.i18n('mci.page').': '.getDefault($currentPage->pageTitle).'</a>');

  if ($_REQUEST['block']=='') 
    $propertiesItemStyle = 'entry-selected"><img src="interface/img/btn_treenode_closed.gif" align="right"/>'; 
  else 
    $propertiesItemStyle = '">';
  
  print('<div blockid="'.$block['guid'].'" class="blockentry '.$propertiesItemStyle.'    
    <img align="absmiddle" src="interface/img/ico_info16.png" class="ddhandle"/>
    <a href="'.selfUrl(array('block' => '')).'">'.
    i18n('mci.pageproperties').'</a>
    </div>');
    
  //$firstMainBlockId = $contentNode->getFirstBlockId();

  foreach ($pageSections as $section)
  {
    $psctr++;
    $blocks = $currentPage->getBlockList($section['id']);
    $bordertop = '';
    //if ($psctr != 1) $bordertop = 'margin-top: 6px;';
    $firstBlockId = null;
    ob_start();
    if (is_array($blocks))
      foreach ($blocks as $block)
      {
        if ($firstBlockId == null) $firstBlockId = $block['guid'];
        $bctr++;
        $style = ''; $selicon = ''; $dellink = '';
        if ($blocknr == $block['guid'])
        {
          $style = 'entry-selected';
          $selicon = '<img src="interface/img/btn_treenode_closed.gif" align="right"/>';
        }
        $imgico = 'interface/img/ico_block_'.$block['type'].'.png';
        if (!file_exists($imgico))
          $imgico = 'interface/img/ico_block_default.png';
        print('
          <div style="overflow: hidden;" class="blockentry '.$style.'" blockid="'.$block['guid'].'">'.$selicon.'
          <img align="absmiddle" src="'.$imgico.'" class="ddhandle"/>
          <a href="'.selfUrl(array('block' => $block['guid'])).'">'.
          abbreviate(getDefault($block['internalname'], i18n('mci.unnamed')), 24).'</a>
          </div>');
      }
    $blockContent = ob_get_clean();
    print('
      <div class="blockheader">
      <a href="'.selfUrl(array(
        'cmd' => 'new',
        'section' => $section['id'],
        )).'">
        <img border="0" src="interface/img/btn_plus16.png" align="right"
          title="'.i18n('mci.hint.addblock').'" alt="'.i18n('mci.hint.addblock').'"></a>
      <a href="'.selfUrl(array('block' => $firstBlockId)).'">
      '.$section['caption'].'</a>
      </div><div id="blocklist_'.$section['id'].'">');
    print($blockContent);
    print('</div><script type="text/javascript" language="javascript" charset="utf-8">
      // <![CDATA[
        Sortable.create("blocklist_'.$section['id'].'",{
          containment:["blocklist_'.$section['id'].'"],
          tag:"div",
          xhandle:"ddhandle",
          onChange: function (element)
          {
            var container = document.getElementById("blocklist_'.$section['id'].'");
            var item = container.firstChild;
            var blocklist = "";
            while (item != null)
            {
              blocklist = blocklist + item.getAttribute("blockid") + ",";
              item = item.nextSibling;
            }
            sendRPC("blockorder", "<blocks node=\"'.$currentNodeNr.
              '\" section=\"'.$section['id'].'\">"+blocklist+"</blocks>");
          }
        });
      // ]]>
      </script>');
  }

  include('interface/admin/footer.php');
?>
