<?
  /* File:    interface/admin/screen_content/show_properties.block.php: is called by
   *          > interface/admin/screen_content/show_properties.php, displays the properties
   *          form of a selected block
   * Type:    user interface
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    /
   * Changes: - modified to use the new CMSForm object
   */

  include_once('lib/fileutils.php');
  include_once('lib/cmsform.class.php');
  include_once('lib/contentblock.class.php');

  // get the current block from the node
  $currentBlock = new ContentBlock($currentPage, $blocknr);

  include($currentPage->getManifestFilename());
  include('etc/interface.properties.block.php');

  $currentBlock->data['language'] = $_SESSION['editlanguage'];

  // create the form object
  $form = new CMSForm(
    $currentBlock->type,                                    // draw the fields from the blockfields table
    null, null,
    array(
      'language' => getDefault($_SESSION['editlanguage'], $site->config['site']['defaultlanguage']),
      'specialfields' => array(                         // display common header on top
        array('children' => array($typeDef, $styleDef, $sectionDef, $langSDef))))
    );
    
  $fileBlockEditor = 'interface/block_editors/'.$currentBlock->type;

  // bind formdataset to block dataset
  $form->dataSet = &$currentBlock->data;
  //print($itemsViewer);
  if ($form->getData())
  {
    // include block-specific save handler
    @include('interface/block_editors/'.$currentBlock->type.'.save.php');
  
    // save handler
    $currentBlock->update($form->dataSet);
    $refreshBlockList = true;

    if ($currentPage->currentLanguage != $_REQUEST['fld_language'])
    {
      $_SESSION['editlanguage'] = $_REQUEST['fld_language'];
      $currentPage->currentLanguage = $_REQUEST['fld_language'];
      $form->formLanguage = $currentPage->currentLanguage;
    }
    
    $BlockPiece = explode('.',$currentBlock->data['style']);
    if($BlockPiece[0]!=$currentBlock->type)
      $currentBlock->data['style'] = $currentBlock->type.'.php';
    
    print('<script src="interface/scripts/admin.js"></script>
        <script>openFrame("frm_items", "?m='.$itemsViewer.'&node='.
        $currentNodeNr.'&listentry='.$currentNodeNr.'&block='.
        $currentBlock->guid.'&nopropertiesupdate=true")</script>');

    $currentBlock = new ContentBlock($currentPage, $blocknr);
    include('etc/interface.properties.block.php');
    $form = new CMSForm(
      $currentBlock->type,                                    // draw the fields from the blockfields table
      null, null,
      array(
        'language' => $currentPage->currentLanguage,
        'specialfields' => array(                         // display common header on top
          array('children' => array($typeDef, $styleDef, $sectionDef, $langSDef))))
      );
    $form->dataSet = &$currentBlock->data;
  }

  //$docHeaderStyle = 'margin-top: -19px; ';
  $form->formCaption = $currentBlock->typeName.' - '.i18n('mci.blockproperties');
  
  $form->toolBarContent = '<a class="toolbutton" style="padding: 4px;"
      href="javascript:openFrame(\'frm_items\', \'?m='.$itemsViewer.'&node='.
        $currentNodeNr.'&listentry='.$currentNodeNr.'&cmd=del&block='.
        $blocknr.'&nopropertiesupdate=false\')">
      <img align="absmiddle" src="interface/img/ico_delete.png"/> '.i18n('mci.blockdelete').'</a>';
  
  @include('interface/block_editors/'.$currentBlock->type.'.php');
  
  $form->params['cmd'] = 'saveblock';
  $form->params['node'] = $node;
  $form->params['ignoreFormChange'] = 'false';
  $form->params['block'] = $blocknr;
  $form->params['oldlanguage'] = $currentPage->currentLanguage;
  $form->params['oldblockname'] = $blockTypeName;
  $form->params['oldinternalname'] = $currentBlock->data['internalname'];
  $form->params['oldsection'] = $currentBlock->data['section'];
  $form->display();
  
  /*
  print('<a href="'.selfUrl(array('import' => 'yes')).'">import</a><p/>');

  if ($_REQUEST['import']=='yes')
  {
    include_once('lib/sites.php');
    //importSite($site->siteID, $site->rootNode, implode(file('etc/newsite.template.xml')));
    importSite(6, 111, implode(file('etc/newsite.template.xml')));
  }
  */
?>
