<?
  /* File:    -
   * Type:    CMS user interface
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    -
   * Changes: -
   */

  include('interface/admin/header.php');
  include_once('lib/cms.simplesqllist.class.php');
  include_once('lib/versioning.php');
  include_once('lib/conversion.php');

  function getPagePath($itemkey, $versionID)
  {
    $result = array();
    while ($itemkey != 0)
    {
      $DS = DB_GetDatasetWQuery('SELECT * FROM '.getTableName('pages').
        ' LEFT JOIN '.getTableName('versioncontent').'
          ON (p_key = c_ref_node AND c_ref_version="'.$versionID.'")
          WHERE p_key="'.$itemkey.'"');
      $pageDS = unserialize($DS['c_node']);
      $result[$DS['p_key']] = getDefault($pageDS['p_caption'], $DS['p_caption']);
      $itemkey = $DS['p_ref_parent'];
    }
    $result = array_reverse($result, true);
    return($result);
  }

  $versionID = getDefault($_REQUEST['versionid'], ver_get_currentkey());
  $versionDS = DB_GetDataset('versions', $versionID);

?>

  <div class="FrameToolbar">&nbsp;&nbsp;
    <span class="frameToolbarText">
      <?= i18n('mci.version.edit').' '.
        getDefault($versionDS['v_name'], DissectTimeStamp($versionDS['v_stamp'])) ?>
    </span>
  </div>

<?

  $changesQuery = ' FROM '.getTableName('versioncontent').
    ' LEFT JOIN '.getTableName('pages').' ON (p_key = c_ref_node)
      WHERE c_ref_version="'.$versionID.'" ';

  function onDisplayRow(&$itemDS, &$itemCaptions)
  {
    global $versionID;

    // get the full page name and path from DB
    $pageDS = unserialize($itemDS['c_node']);
    $path = getPagePath($itemDS['c_ref_node'], $versionID);
    $pathCaption = implode('/', $path);

    // determine the color settings for this row
    if ($itemDS['p_ref_version'] == $versionID)
    {
      $itemIsDeleted = false;
      $itemCaptions['status'] = i18n('mci.version.status.new');
      $itemCaptions['/rowstyle'] = 'color: green';
      $folder = '_green';
      $itemIsNew = true;
    }
    else if ($itemDS['c_status'] == 'D')
    {
      $itemIsNew = false;
      $itemIsDeleted = true;
      $itemCaptions['status'] = i18n('mci.version.status.deleted');
      $itemCaptions['/rowstyle'] = 'color: red';
      $folder = '_red';
    }
    else
    {
      $itemIsNew = false;
      $itemIsDeleted = false;
      $itemCaptions['status'] = i18n('mci.version.status.modified');
      $itemCaptions['/rowstyle'] = 'color: blue';
      $folder = '_blue';
    }

    $editlink = '?m=admin&i=content&node='.$itemDS['c_ref_node'];

    // fill in the page path cell
    $itemCaptions['pagepath'] = '<a target="_parent" href="'.$editlink.'"
      style="'.$itemCaptions['/rowstyle'].'" title="'.i18n('mci.versionedit.jump').'">
      <img src="interface/img/folder'.$folder.'.png"
        alt="'.i18n('mci.versionedit.jump').'" title="'.i18n('mci.versionedit.jump').'"
        align="absmiddle" border="0"/>
        '.getDefault($pathCaption, '(unnamed)').'</a>';

    // see if there is an "original name" to this document
    if ($itemDS['p_caption'] != $pageDS['p_caption'] && $itemDS['p_status'] != 'H')
      $itemCaptions['origname'] = (' <span style="color: gray">('.getDefault(
        $itemDS['p_caption'], 'unnamed').')</span> ');

    // lastly, display the action options for this row
    if (!$itemIsDeleted)
      $actions[] = array('id' => 'preview', 'ico' => 'ico_preview_version16.png',
          'link' => '?m=admin&i=preview&node='.$itemDS['p_key'], 'target' => '_parent');
    else
      $actions[] = array('id' => 'space', 'link' => '');    
    
    if (!$itemIsNew)
      $actions[] = array('id' => 'original', 'ico' => 'ico_preview16.png', 'link' => '');
    else
      $actions[] = array('id' => 'space', 'link' => '');    
      
    $actions[] = array('id' => 'delete', 'ico' => 'ico_delete.png', 
      'link' => selfUrl(array('lcmd' => 'delete', 'item' => $itemDS['c_key'])));

    foreach ($actions as $action)
    {
      if ($action['id'] == 'space')
        $opts .= ' <img src="interface/img/transparent.gif" style="padding-right: 0px;"/> ';
      else
        $opts .= '<a target="'.$action['target'].'" href="'.$action['link'].'">
          <img src="interface/img/'.$action['ico'].'" border="0"
            alt="'.i18n('mci.versionedit.'.$action['id']).'" title="'.i18n('mci.versionedit.'.$action['id']).'"/></a>';
    }
    $itemCaptions['options'] = $opts;
  }
  
  if ($_REQUEST['lcmd'] == 'delete')
  {
    DB_RemoveDataset('versioncontent', $_REQUEST['item']);
  }

  $sqlView = new SimpleSQLList($changesQuery);
  $sqlView->onDisplayRow = 'onDisplayRow';
  $sqlView->columns = array(
    array('id' => 'pagepath', 'caption' => 'mci.version.page'),
    array('id' => 'origname', 'caption' => 'mci.version.origname'),
    array('id' => 'status', 'caption' => 'mci.version.status'),
    array('id' => 'options', 'caption' => 'mci.version.options'),
    );
  $sqlView->prepare();
  $sqlView->display();

  $commitLink = '?m=admin/screen_overview/version_commit&version='.$versionID;

  print('<div style="padding-left: 00px;"><b><img src="interface/img/ico_version16.png" align="absmiddle"/>
    Commit changes to live website</b></div><div style="padding-left: 20px;">
    <a href="'.$commitLink.'">Click here</a> 
    to make all of the changes above appear on your public
    website now.<br/>
    <input style="margin-top: 4px;" type="button" name="" 
      onclick="document.location=\''.$commitLink.'\';"
      value="Commit Changes &gt;"/></div>
    ');

  include('interface/admin/footer.php');

?>
