<?
  /* File:    -
   * Type:    CMS user interface
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    -
   * Changes: -
   */

  include_once('lib/fileutils.php');                                            // file i/o utilities
  include_once('lib/cmsform.class.php');                                        // include the form class
  include_once('lib/ajaxtools.php');                                            // some AJAX functions
  include_once('lib/xml2array.php');

  include('interface/admin/header.php');                                        // standard admin header
  print('<script src="interface/scripts/admin.js"></script>');                  // admin javascript functions

  $feedDS = DB_GetDataset('settings', $_REQUEST['feed']);                       // get the feed's settings from DB
  $feedSettings = unserialize($feedDS['s_content']);                            // unserialize the settings array
  $feedSettings['name'] = $feedDS['s_value'];                                   // overwrite the feed name

  $form = new CMSForm(':feeds.editfeed', null, null, array());                  // init the config form

  $blockDef[] = array(                                                          // field for the feed's name
    'bf_caption' => i18n('mci.feeds.import.url'),
    'bf_fieldname' => 'atom_url',
    'bf_type' => 'string',
    'bf_default' => 'http://',
    );

  $form->fields = $blockDef;
  $form->dataSet = $importSettings;

  if ($form->getData())
  {
    $url = $form->dataSet['atom_url'];
    if (substr($url, 0, 7)!='http://') $url = 'http://'.$url;
    print('Retrieving data from '.$url.'<br/><br/>');
    ob_flush();
    $feedContent = implode('', file($url));
    print('- '.strlen($feedContent).'bytes read.<br/>');
    $feedXML = xml2array($feedContent);
    print('- Blog Title: '.$feedXML['feed'][0]['title'][0]['$'].' ('.
      $feedXML['feed'][0]['tagline'][0]['$'].')<br/>');
    print('- Entries found: '.sizeof($feedXML['feed'][0]['entry']).'<br/><br/>');
    foreach ($feedXML['feed'][0]['entry'] as $entry)
    {
      $postTitle = $entry['title'][0]['$'];
      $postContent = $entry['content'][0]['$'];
      
      print('<li>'.$postTitle.'</li>');
      
    }
    WriteToFile('log/import.feed.'.$feedDS['s_key'].'.atom.xml', $feedContent);  
    print('<p/><a href="'.selfUrl(array('doimport' => 'true')).'">Import these items now?</a>');
  }
  //else
  {
    $form->formCaption = '&nbsp;&nbsp;<span class="frameToolbarText">'.i18n('mci.feeds.importfeed').
      ': '.$feedDS['s_value'].'</span>';
    $form->params['feed'] = $_REQUEST['feed'];
    $form->display();
  }
  
  include('interface/admin/footer.php');                                        // standard admin footer

?>
