<?
  /* File:    -
   * Type:    CMS user interface
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    -
   * Changes: -
   */

  include_once('lib/fileutils.php');                                            // file i/o utilities
  include_once('lib/cmsform.class.php');                                        // include the form class
  include_once('lib/ajaxtools.php');                                            // some AJAX functions

  include('interface/admin/header.php');                                        // standard admin header
  print('<script src="interface/scripts/admin.js"></script>');                  // admin javascript functions

  $feedDS = DB_GetDataset('settings', $_REQUEST['feed']);                       // get the feed's settings from DB
  $feedSettings = unserialize($feedDS['s_content']);                            // unserialize the settings array
  $feedSettings['name'] = $feedDS['s_value'];                                   // overwrite the feed name

  $form = new CMSForm(':feeds.editfeed', null, null, array());                  // init the config form

  $blockDef[] = array(                                                          // field for the feed's name
    'bf_caption' => i18n('mci.feeds.name'),
    'bf_fieldname' => 'name',
    'bf_type' => 'string',
    );

  $blockDef[] = array(                                                        // localized feed description
      'bf_caption' => i18n('mci.feeds.template'),
      'bf_fieldname' => 'detailtemplate',
      'bf_type' => 'dropdown',
      'bf_options' => getFileList('themes/'.$config['site']['theme'].'/pages/',
        array('match' => '/\.manifest\.php$/',
          'replacecapt' => array('.manifest.php', ' template'))),
      );

  foreach ($config['site']['language'] as $langid => $lang)                     // these settings are applied
  {                                                                             // per language
    $blockDef[] = array(
      'bf_type' => 'spacer',
      );
    $blockDef[] = array(                                                        // checkbox for RSS publication
      'bf_caption2' => i18n('mci.feeds.publish').':                             
        <span style="color: green; font-weight: bold;">'.$lang.
        '</span> ('.$langid.')',
      'bf_fieldname' => 'publish:'.$langid,
      'bf_type' => 'checkbox',
      );
    $blockDef[] = array(                                                        // localized feed title
      'bf_caption' => i18n('mci.feeds.title'),
      'bf_fieldname' => 'title:'.$langid,
      'bf_type' => 'string',
      'bf_default' => $feedDS['s_value'],
      );
    $blockDef[] = array(                                                        // localized feed description
      'bf_caption' => i18n('mci.feeds.description'),
      'bf_fieldname' => 'description:'.$langid,
      'bf_type' => 'string',
      );
  }

  $blockDef[] = array(
    'bf_caption' => '',
    'bf_fieldname' => '',
    'bf_type' => 'custom',
    'bf_data' => 'interface/admin/screen_settings/feeds_published_options.php',
    );

  $form->toolBarContent = '<a class="toolbutton" style="padding: 4px;"
      href="javascript:openFrame(\'frm_items\', \'?m=admin/screen_settings/feeds&feed='.
        $_REQUEST['feed'].'&cmd=dellist\')">
      <img align="absmiddle" src="interface/img/ico_delete.png"/> Delete</a>';

  $form->fields = $blockDef;
  $form->dataSet = $feedSettings;

  if ($form->getData())
  {
    $feedDS['s_content'] = serialize($form->dataSet);
    $feedDS['s_value'] = $form->dataSet['name'];
    DB_UpdateDataset('settings', $feedDS);
  }

  $form->formCaption = '&nbsp;&nbsp;<span class="frameToolbarText">'.i18n('mci.feeds.editfeed').
    ': '.$feedDS['s_value'].'</span>';
  $form->params['feed'] = $_REQUEST['feed'];
  $form->display();

  include('interface/admin/footer.php');

?>
<h2><?= i18n('mci.pageproperties.whatsnext') ?></h2>
<div class="quickAccessDiv" onclick="document.location='<?= selfUrl(array(
  'feed' => $feedDS['s_key'],
  'm' => 'admin/screen_settings/feeds_importfeed')) ?>';">
  <img src="interface/img/ico_edit16.png" align="absmiddle"/>
  <?= i18n('mci.feeds.importfeed') ?>
</div>
