<?
  /* File:    interface/admin/screen_settings/templates.php: displays a list of templates
   *          for pages and blocks, also provides functionality to create them
   * Type:    user interface
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    - support for multiple sites
   * Changes: /
   */

  include_once('lib/fileutils.php');
  include_once('lib/contentnode.class.php');
  include_once('etc/settings.modules.php');
  include('interface/admin/header.php');
  include_once('lib/cms.displaylist.php');
  print('<script src="interface/scripts/admin.js"></script>');
  if ($_REQUEST['childrefresh'] != 'no')
    print('<script>openFrame("frm_properties", "");</script>');

  $elements[] = array(
    'path' => 'pages',
    'ext' => 'php',
    'icon' => 'ico_templates.png',
    'caption' => i18n('mci.pagetemplates'),
    );
  $elements[] = array(
    'path' => 'css',
    'ext' => 'css',
    'icon' => 'ico_down16.png',
    'caption' => i18n('mci.styles'),
    );
  $elements[] = array(
    'path' => 'include',
    'ext' => 'php',
    'icon' => 'ico_block_include.png',
    'caption' => i18n('mci.includes'),
    );
  $elements[] = array(
    'path' => 'elements',
    'ext' => 'php',
    'icon' => 'ico_block16.png',
    'caption' => i18n('mci.elements'),
    );
  $elements[] = array(
    'path' => 'blocks',
    'ext' => 'php',
    'icon' => 'ico_block_default.png',
    'caption' => i18n('mci.blocks'),
    );

  foreach ($elements as $elementType)
  {
    $typeLink = '&type='.$elementType['path'].'&ext='.$elementType['ext'];
    $elementPath = 'themes/'.$config['site']['theme'].'/'.$elementType['path'].'/';
    if ($cmsUser['us_isadminuser'] == 'Y')
    {
      $editLink = '<a href="?m=admin/screen_settings/templates&cmd=new'.
        $typeLink.'"><img border="0" src="interface/img/btn_plus16.png" align="right"></a>';
      if ($_REQUEST['cmd'] == 'new' && $elementType['path'] == $_REQUEST['type'])
      {
        include_once('lib/fileutils.php');
        $newFile = makeUniqueFilename($elementPath, 'unnamed', $elementType['ext']);
        WriteToFile($elementPath.$newFile, ' ');
      }
    }
    print('<div class="blockheader">
      '.$editLink.$elementType['caption'].'</div>');   
    $itemList = getFileList($elementPath, array());
    $templateList = array();
    foreach ($itemList as $item)
    {
      $templateFile = $item['id'];
      if (stristr($templateFile, '.manifest.php') == '')
        $templateList[] = array(
          'id'=>'?m=admin/screen_settings/templates_editor'.$typeLink.
            '&template='.urlencode($item['id']),
          'icon'=>'interface/img/'.$elementType['icon'],
          'title'=> $templateFile,
          );
    }
    displaySimpleList($templateList, 'frm_properties');
  }

  /*
  print('<div class="blockheader">
    <a href="?m=admin/screen_settings/templates&cmd=newpage">
    <img border="0" src="interface/img/btn_plus16.png" align="right"></a>
    Page Templates</div>');

  $pathBase = 'themes/'.$config['site']['theme'].'/';

  if ($cmsUser['us_isadminuser'] == 'Y')
    switch ($_REQUEST['cmd'])
    {
      case('newpage'):
      {
        $newFile = getNewFileName($pathBase.'pages/page', '.php');
        WriteToFile($newFile, implode("", file('interface/admin/blueprint/pagetemplate.php')));
        $newManifest = str_replace('.php', '', $newFile).'.manifest.php';
        WriteToFile($newManifest, implode("", file('interface/admin/blueprint/pagetemplate.manifest.php')));
        break;
      }
      case('newblock'):
      {
        $newFile = getNewFileName($pathBase.'blocks/'.$_REQUEST['block'].'.style', '.php');
        $templateFile = 'interface/admin/blueprint/blocktemplate.'.$_REQUEST['block'].'.php';
        if (!file_exists($templateFile))
          $templateFile = 'interface/admin/blueprint/blocktemplate.php';
        WriteToFile($newFile, implode("", file($templateFile)));
        break;
      }
    }

  $pageTemplates = getFileList('themes/'.$config['site']['theme'].'/pages/',
    array('match' => '/\.manifest\.php$/'));

  foreach ($pageTemplates as $item)
  {
    $templateFile = str_replace('.manifest.php', '.php', $item['id']);
    $pageTemplateList[] = array(
      'id'=>'?m=admin/screen_settings/templates_edit_page&template='.urlencode($item['id']),
      'icon'=>'interface/img/ico_templates.png',
      'title'=> $templateFile,
      );
  }

  displaySimpleList($pageTemplateList, 'frm_properties');

  // ---------------------

  print('<div class="blockheader"> '.i18n('mci.styles').'</div>');
  $styleTemplates = getFileList('themes/'.$config['site']['theme'].'/css/',
    array());

  foreach ($styleTemplates as $item)
  {
    $templateFile = $item['id'];
    $styleTemplateList[] = array(
      'id'=>'?m=admin/screen_settings/templates_edit_style&template='.urlencode($item['id']),
      'icon'=>'interface/img/ico_down16.png',
      'title'=> $templateFile,
      );
  }

  displaySimpleList($styleTemplateList, 'frm_properties');

  // ---------------------

  print('<div class="blockheader"> '.i18n('mci.includes').'</div>');
  $includeTemplateList = getFileList('themes/'.$config['site']['theme'].'/include/',
    array());

  foreach ($includeTemplateList as $item)
  {
    $templateFile = $item['id'];
    $includeTemplates[] = array(
      'id'=>'?m=admin/screen_settings/templates_edit_include&template='.urlencode($item['id']),
      'icon'=>'interface/img/ico_block_include.png',
      'title'=> $templateFile,
      );
  }

  displaySimpleList($includeTemplates, 'frm_properties');

  // ---------------------

  print('<div class="blockheader"> '.i18n('mci.elements').'</div>');
  $elementTemplates = getFileList(
    'themes/'.$config['site']['theme'].'/elements/', array());

  foreach ($elementTemplates as $item)
  {
    $templateFile = $item['id'];
    $elementTemplateList[] = array(
      'id'=>'?m=admin/screen_settings/templates_edit_element&template='.urlencode($item['id']),
      'icon'=>'interface/img/ico_block16.png',
      'title'=> $templateFile,
      );
  }

  displaySimpleList($elementTemplateList, 'frm_properties');

  // ---------------------

  global $site;
  $blockList = DB_GetList('SELECT * FROM '.getTableName('blocks').' 
    WHERE refSiteID="'.$site->siteId.'" ORDER BY b_caption');

  foreach ($blockList as $blockType)
  {

    if ($cmsUser['us_isadminuser'] == 'Y')
      $addBtn = '<a href="?m=admin/screen_settings/templates&cmd=newblock&block='.urlencode($blockType['b_key']).'">
        <img border="0" src="interface/img/btn_plus16.png" align="right"></a>
        '.$blockType['b_caption'];  
      
    print('<div class="blockheader">'.$addBtn.' Block </div>');

    $blockTemplates = getFileList('themes/'.$config['site']['theme'].'/blocks/',
      array('match' => '/^'.$blockType['b_key'].'\.*./'));

    $blockTemplateList = array();
    foreach ($blockTemplates as $item)
    {
      $icon = 'interface/img/ico_block_'.$blockType['b_key'].'.png';
      if (!file_exists($icon))
        $icon = 'interface/img/ico_block22.png';

      $blockTemplateList[] = array(
        'id'=>'?m=admin/screen_settings/templates_edit_block&block='.urlencode($blockType['b_key']).
          '&template='.urlencode($item['id']),
        'icon' => $icon,
        'title'=> $item['id'],
        );
    }

    displaySimpleList($blockTemplateList, 'frm_properties');

  }
  */
  
  include('interface/admin/footer.php');

?>
