<?
  /* File:    interface/admin/rpc.php: this is the main RPC handler. Its
   *          purpose is to take any incoming XML or SOAP request that was
   *          addressed to the ?m=admin/rpc URL. It doesn't do any processing
   *          in itself besides decoding the XML document into the $request
   *          variable and passing that on to whatever module was specified
   *          in the module attribute of the XML request item
   * Type:    handler
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    /
   * Changes: -
   */

  include_once('lib/xml2array.php');

  $postData = getDefault($GLOBALS['HTTP_RAW_POST_DATA'], $_REQUEST['request']);
  if (get_magic_quotes_gpc()) $postData = strip_slashes($postData);
  
  //logToFile('log/err.rpc.log', $postData);
    
  $request = xml2array($postData);
  
  if (is_array($request['req']))
    foreach ($request['req'] as $reqItem)
    {                 
      $handler = 'interface/admin2/rpc/'.$reqItem['@']['module'].'.php';
      if (file_exists($handler))
      {
        print('<rpcresponse status="called">');
        include($handler);
      }
      else
      {
        print('<rpcresponse status="error" msg="module not found: '.$reqItem['@']['module'].'">');
        logToFile('log/err.rpc.log', 'module not found: '.$handler."\n".
          getArrayDump($GLOBALS));
      }
    }
  else
    logToFile('log/err.rpc.log', 'Cannot read request:'."\n".
      getArrayDump($postData)."\n\nparsed as:\n".getArrayDump($request)."\n\nTRACE:\n".
      getArrayDump($GLOBALS));

?></rpcresponse><? die(); ?>
