<?php
/* File:
 * Type:    CMS function library
 * Author:  udo.schroeter@gmail.com
 * License: commercially licensed as part of the CMS package
 * Todo:    /
 * Changes: -
 */

 class CiteSite
 {
   var $currentModule;
   var $siteDS;
   var $siteID;
   var $subdirectory;
   var $siteName;
   var $currentLanguage;
   var $config;
   var $rootNode;
   var $cmsUser;

   function CiteSite($siteID = 1, $identifierField = 's_key')
   {
     global $currentSiteRootNode, $currentSiteID, $config, $currentLanguage;
     $this->currentModule = getModuleName();
     
     if (substr($this->currentModule, 0, 15) == 'interface/admin')
     {
       if ($_SESSION['cmsuser']['refSiteID'] > -1)
       {
         $siteID = $_SESSION['cmsuser']['refSiteID'];
         $identifierField = 's_key';
       }
     }
     $this->config = &$config;
     $this->siteDS = DB_GetDataset('sites', $siteID, $identifierField);
     if (sizeof($this->siteDS)==0) $this->siteDS = DB_GetDataset('sites', 1, 's_key');
     if (sizeof($this->siteDS)==0) return;
     //logToFile('log/site.log', $this->siteDS);
     $currentSiteRootNode = $this->siteDS['s_home_node'];
     $currentSiteID = $this->siteDS['s_key'];
     $this->siteName = $this->siteDS['s_name'];
     $config['cms']['versioning'] = $this->siteDS['s_versioning'] == 'Y';
     $this->theme = $this->siteDS['s_theme'];
     $config['site']['theme'] = $this->siteDS['s_theme'];
     $this->siteID = $this->siteDS['s_key'];
     if ($this->siteDS['s_home_node']!='')
       $this->subdirectory = $this->siteDS['s_subdirectory'];
     $config['site']['dsid'] = $this->siteDS['s_key'];
     $config['site']['defaultnode'] = $this->siteDS['s_home_node'];
     $config['site']['home_node'] = $this->siteDS['s_home_node'];
     $this->rootNode = $this->siteDS['s_home_node'];
     $config['site']['urlrewrite'] = $this->siteDS['s_urlrewrite'] == 'Y';
     $config['site']['urlrewrite_method'] = $this->siteDS['s_urlrewrite_method'];
     $config['site']['urlrewrite_pathseparator'] = $this->siteDS['s_urlrewrite_pathseparator'];
     $config['site']['urlrewrite_autoname'] = $this->siteDS['s_urlrewrite_autoname'];
     $config['site']['sitename']['en'] = $this->siteDS['s_name'];
     $this->readSettingsFromDB();
     if(is_array($config['site']['language']))
       foreach ($config['site']['language'] as $langid => $lang)
       {
         $config['site']['defaultlanguage'] = $langid;
         break;              
       }     
     
     //$config['site']['defaultlanguage'] = 'de';
     // language settings
     if (isset($_REQUEST['lang']))
       $_SESSION['currentlang'] = $_REQUEST['lang'];
    
     $_SESSION['currentlang'] =
       getDefault($_SESSION['currentlang'], $config['site']['defaultlanguage']);
     $currentLanguage = $_SESSION['currentlang'];
     $this->currentLanguage = $currentLanguage;
     
     $this->caption = getDefault($config['site']['sitecaption'][$currentLanguage],
       '(Trionic Cite)');
       
     $this->cmsUser = &$_SESSION['cmsuser'];
   }

   function readSettingsFromDB()
   {
     global $config;
     $settingsQuery = 'SELECT s_type,s_name,s_value FROM '.getTableName('settings').'
       WHERE s_container="config" AND refSiteID="'.$this->siteID.'" ORDER BY s_order';
     $settings = DB_GetList($settingsQuery);
     if (sizeof($settings)>0)
       foreach ($settings as $item)
       {
         $config['site'][$item['s_type']][$item['s_name']] = $item['s_value'];
       }
   }

   function processRequest()
   {
     global $config;
     include($this->currentModule);
   }

 }

?>
