<?
  /* File:    cms.displaylist.php: general functions for displaying simple lists
   * Type:    CMS function library
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    /
   * Changes: -
   */

  function displaySimpleList($list, $linktarget = 'frm_items', $options = array())
  {
    global $config;
    if (sizeof($list)==0)
      print('<span style="color: gray">&nbsp;'.i18n('mci.empty.list').'</a>');
    else
    {
      print('<table cellspacing="0" cellpadding="3" width="100%">');
      foreach ($list as $module)
      {
        //$open = 'javascript:openFrame(\''.$linktarget.'\', \''.$module['id'].'\')';
        $open = selfUrl(array('listselect' => $module['id']));
        $moduleIdClean = $module['id'];
        if (stristr($moduleIdClean, '?m=')!='') CutSegment('?m=', $moduleIdClean);
        $module['title'] = getDefault($module['title'], $module['caption']);
        $caption = getDefault(i18n('mci.'.$module['title'], true), i18n('mci.'.$moduleIdClean, true));
        $caption = getDefault($caption, $module['title']);
        $style = '';
        if ($module['id'] == $_REQUEST['listselect'])
        {
          $style = 'entry-selected';

          $openlink = '<script>openFrame(\''.$linktarget.'\', \''.
            $options['linkprefix'].$module['id'].'\')</script>';
        }
        $module['icon'] = getDefault($module['icon'],
          'interface/img/icons/'.$module['caption'].'.png');
        print('
          <tr class="'.$style.'"><td width="24"><div align="center">
          <a href="'.$open.'">
          <img align="absmiddle" src="'.$module['icon'].'"/></a>
          </td><td><a href="'.$open.'">
          '.$caption.'</a></td></tr>');
      }
      print('</table>');
      if (isset($_REQUEST['listselect']))
      {
        print($openlink);
      }
    }
  }
  
  function displayListHeader($caption)
  {
    print('<div class="blockheader">'.$caption.'</div>');
  }

  function displayDataTable($data, $properties = array())
  {
    global $config, $gridCount;
    $hctr = -1;
    $gridCount++;

    if (sizeof($data[0]) == 0)
    {
      print('<span style="color: gray">&nbsp;'.i18n('mci.empty.list').'</span>');
      return;
    }
    foreach ($data[0] as $k => $v)
    {
      $hctr++;
      if (!isset($properties['key']))
        $properties['key'] = $k;
      $header[$k] = i18n('mci.'.$k);
      $header[$k] = getDefault($header[$k], $k);
      if ($k == $properties['key']) $properties['key#'] = $hctr;
    }
  ?>

  	<style> body, html {margin:0px; padding: 0px; overflow: hidden;} </style>

  	<link href="interface/scripts/activewidgets/styles/xp/grid.css" rel="stylesheet" type="text/css" ></link>
  	<script src="interface/scripts/activewidgets/lib/grid.js"></script>

  	<style>
  		.active-controls-grid {height: 100%; font: menu;}
  	<?
  	  if (getDefault($properties['colwidths'])!='')
  	  {
  	    $colwidths = explode(',', $properties['colwidths']);
  	    $colctr = -1;
        foreach ($colwidths as $width)
  	    {
          $colctr++;
          print('.active-column-'.$colctr.' {width: '.$width.'px;} ');
        }
  	  }
  	?>
  		.active-box-image {height: 16px;} /* for firefox 0.8 */
  	</style>

  	<script>

		var myData = [ <?

  		foreach ($data as $item)
      {
        $items = array();
        foreach ($header as $k => $dfield)
          $items[] = '"'.mysql_escape_string(htmlentities($item[$k])).'"';
        $lines[] = '[ '.implode(', ', $items).' ]';
      }

  		$hdr = array();
  		foreach ($header as $k => $dfield)
        $hdr[] = '"'.$dfield.'"';

  		print(implode(', ', $lines));

    ?> ];

		var myColumns = [
			<?= implode(', ', $hdr) ?>
		];

  	var obj = new Active.Controls.Grid;
  	obj.setColumnTemplate(new Active.Templates.Image, 0);
  	obj.setRowProperty("count", <?= sizeof($data) ?>);
  	obj.setColumnProperty("count", <?= sizeof($header) ?>);
  	obj.setDataProperty("text", function(i, j){return myData[i][j]});
  	obj.setColumnProperty("text", function(i){return myColumns[i]});
  	obj.setColumnHeaderHeight("20px");
  	obj.setRowHeaderWidth("0px");

    function rowDblClick<?= $gridCount ?> (src)
    {
      var rowKey = (myData[src.getProperty("item/index")]['<?= $properties['key#'] ?>']);
      <?= $properties['openurl.handler'] ?>
    }
    function rowClick<?= $gridCount ?> (src)
    {
      var rowKey = (myData[src.getProperty("item/index")]['<?= $properties['key#'] ?>']);
      <?= $properties['rowclick.handler'] ?>
    }
    function rowSelect<?= $gridCount ?> (src)
    {
      var rowKey = (myData[this.getSelectionProperty("index")]['<?= $properties['key#'] ?>']);
      document.currentRow = rowKey;
    }

		var row = new Active.Templates.Row;
    row.setEvent("ondblclick", function(){this.action("rowDblClick")});
  	row.setEvent("onmousedown", function(){this.action("rowClick")});
  	obj.setTemplate("row", row);
    obj.setAction("rowDblClick", rowDblClick<?= $gridCount ?>);
    obj.setAction("rowClick", rowClick<?= $gridCount ?>);
    obj.setAction("selectionChanged", rowSelect<?= $gridCount ?>);

    document.write(obj);

  	</script>

  <?
  }

  function displayListCommands($properties)
  {
    print('<table style="background: #f0f0f0; border-bottom: 1px solid #c0c0c0;"
      width="100%" cellspacing="0" cellpadding="0"><tr><td><div align="right">');

    $buttons = array(
      array('id'=> 'javascript:if (document.currentRow && confirm(\''.$properties['msg.delete'].'\'))
      document.location=\''.selfUrl(array('action' => 'delete')).'&select1=\'+document.currentRow;',
        'icon'=>'interface/img/btn_minus16.png', 'title'=>'Delete', 'style' => 'float: left'),
      array('id'=> 'javascript:var rowKey = document.currentRow;'.$properties['openurl.handler'],
        'icon'=>'interface/img/ico_edit16.png', 'title'=>'Edit', 'style' => 'float: right' ),
      array('id'=> 'javascript:var rowKey = \'\';'.getDefault($properties['newitem.handler'], $properties['openurl.handler']),
        'icon'=>'interface/img/btn_plus16.png', 'title'=>'New',
        'style' => 'float: right'),
      );

    foreach ($buttons as $button)
    {
      print('<a class="adminbutton toolbutton" style="width: 57px;'.$button['style'].'" href="'.$button['id'].'">
       <img src="'.$button['icon'].'" border="0" align="absmiddle"/>&nbsp;
       '.getDefault($button['title'], i18n('mci.'.$button['id'])).'</a>');
    }

    print('</td></tr></table>');
  }

  function displaySQLList($properties)
  {
    global $config;
    $properties['openurl.handler'] = getDefault($properties['openurl.handler'],
      "document.location = '".
        getDefault($properties['openurl'], selfUrl(array(),array('select'))).
        "&select".$gridCount."='+rowKey;");
    if (isset($properties['where']))
      $where = ' WHERE '.$properties['where'].' ';
    $usrList = DB_GetList('SELECT '.$properties['fields'].' FROM '.
      getTableName($properties['table']).' '.$where.' ORDER BY '.$properties['orderby']);
    print('<table width="100%" height="100%" cellspacing="0" cellpadding="0">
      <tr><td><div class="header">'.$properties['caption'].'</div></td></tr>
      <tr><td height="100%">');
    displayDataTable($usrList, $properties);
    print('</td></tr><tr><td>');
    displayListCommands($properties);
    print('</td></tr></table>');
  }

?>
