<?
  include_once('lib/conversion.php');

  class SimpleSQLList
  {
    var $maxCount;
    var $offset;
    var $viewFrom;
    var $viewCount;
    var $viewTo;
    var $query;
    var $items;
    var $onDisplayRow;
    var $columns;
    var $table;
    var $tableKey;
    var $colInfo;

    function SimpleSQLList($query = '')
    {
      $this->query = $query;
      $this->maxCount = 10;
      $this->offset = getDefault($_REQUEST['offset'], 0);
      $this->viewFrom = $this->offset+1;
      $this->viewTo = $this->offset+$this->maxCount;
      $this->selectorString = selfUrl();
    }

    function prepare($table = null, $whereList = null, $joinList = null)
    {
      if ($table != null)
      {
        $this->table = $table;
        $this->query = 'FROM '.getTableName($table);
        if ($joinList != null) $this->query .= ' LEFT JOIN '.implode(' LEFT JOIN ', $joinList);
        if ($whereList != null) $this->query .= ' WHERE '.implode(' AND ', $whereList);
      }
      $keys = DB_GetKeys($table);
      $this->tableKey = $keys[0];
      $changesCount = DB_GetDatasetWQuery('SELECT count(*) '.$this->query);
      $this->viewCount = $changesCount['count(*)'];
      if ($this->viewTo > $this->viewCount) $this->viewTo = $this->viewCount;
      if ($this->offset < 0) $this->offset = 0;
      if ($this->offset > $this->viewCount-1) $this->offset = $this->viewCount;
      $this->itemQuery = 'SELECT * '.$this->query.'
        ORDER BY '.$this->tableKey.' DESC
        LIMIT '.($this->offset+0).','.$this->maxCount;
      $this->items = DB_GetList($this->itemQuery);
      $cols = DB_ListFields($table, false, true, false, true);
      $this->colInfo = $cols;
      if (!isset($this->columns))
      {
        foreach ($cols as $item)
          $this->columns[] = array(
            'id' => $item['name'],
            'field' => $item['name'],
            'type' => $item['type'],
            ''
            );
      }
      $this->selectId = getDefault($this->selectId, $_REQUEST['select1']);
    }

    function display()
    {
      // start output of the table
      print('<table width="100%" cellspacing="0" cellpadding="3" bgcolor="#f0f0f0">');
      if (sizeof($this->columns)>1)
      {
        print('<tr height="18" class="blockheader">');
        // first, display the column headers
        foreach ($this->columns as $headerItem)
        {
          $colCaption = getDefault(i18n('dbfields.'.$this->table.'.'.
            $headerItem['field'], true), $headerItem['field']);
          print('<td style="border-bottom: 1px solid #c0c0c0;" width="'.
            getDefault($headerItem['width'], '*').'">'.
            getDefault($colCaption, $headerItem['caption']).'</td>');
        }
        print('</tr>');
        print('<tr bgcolor="#ffffff" height="8"><td colspan="100"></td></tr>');
      }
      // then, output the actual data
      foreach ($this->items as $item)
      {
        $itemcaptions = $item;
        $evtDisplayRow = $this->onDisplayRow;
        if (isset($evtDisplayRow)) $evtDisplayRow($item, $itemcaptions);

        $currentRowKey = $item[$this->tableKey];
        $currentRowStyle = '';
        if ($this->selectId == $currentRowKey)
          $currentRowStyle = ';" class="entry-selected';

        print('<tr height="18" bgcolor="#ffffff" style="border-bottom: 1px solid #c0c0c0; '.$itemcaptions['/rowstyle'].
          $currentRowStyle.'">');

        foreach ($this->columns as $headerItem)
        {
          // default display based on the db rows's field content
          $cellContent = getDefault($itemcaptions[$headerItem['field']], $headerItem['default']);
          $colType = getDefault($headerItem['type'], $this->colInfo[$headerItem['field']]['type']);
          if ($colType == 'timestamp')
          {
            $cellContent = dateTimeToString(timestampToDate($cellContent));
          }
          if ($headerItem['content'] != '')
          {
            // custom cell rendering
            $callBackFunction = $headerItem['content'];
            print('<td nowrap>'.$callBackFunction($itemcaptions, $currentRowKey, $cellContent).'</td>');
          }
          else
          {
            print('<td nowrap><a href="'.$this->selectorString.'&select1='.$currentRowKey.'">'.
              $cellContent.'</a></td>');
          }
        }
        print('</tr>');
      }
      if ($this->maxCount < $this->viewCount)
      {
        if ($this->offset > 0)
          $goback = '<a href="'.selfUrl(array('offset' => $this->offset - $this->maxCount)).'">
            <img src="interface/img/btn_treenode_left.gif" align="absmiddle"/></a>';
        if ($this->offset + $this->maxCount < $this->viewCount)
          $goforward = '<a href="'.selfUrl(array('offset' => $this->offset+$this->maxCount)).'">
            <img src="interface/img/btn_treenode_closed.gif" align="absmiddle"/></a>';
        $navtxt = $goback.'
          viewing items '.$this->viewFrom.' - '.$this->viewTo.' of '.$this->viewCount.$goforward;
      }
      else
      {
        $navtxt = ''.$this->viewCount.' '.i18n('mci.entries.displayed');
      }
      /*print('
        <div align="center" style="position: absolute; bottom: 1px;
          border-top: 1px solid #c0c0c0;
          padding: 4px; background: #e0e0e0; color: gray; width: 94%">'.
        $navtxt.'</div>');*/
      print('</table>');
    }

    function makeButton($href, $caption, $icon, $style = null, $target = '')
    {
      print('<a class="toolbutton" style="'.$style.'; float: left"
        target="'.$target.'" href="'.$href.'">
        <img align="absmiddle" src="interface/img/'.$icon.'"/> '.i18n($caption).'</a>');
    }
  }


?>
