<?
  /* File:    lib/cmsform.class.php: the central class for doing forms in the CMS
   *          $form = new CMSForm($formname);
   * Type:    CMS function library
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    /
   * Changes: -
   */

  include_once('lib/conversion.php');

  function getToolTip(&$ds)
  {
    $tooltipText = '';
    $ds['bf_tooltip'] = getDefault($ds['bf_tooltip'], i18n('mci.help.field.'.
      getDefault($ds['bf_ofieldname'], $ds['bf_fieldname']), true));
    if (trim($ds['bf_tooltip'])!='')
    {
      $tooltipText = '
        onMouseover="ddrivetip(\''.$ds['bf_tooltip'].'\', 180)";
        onMouseout="hideddrivetip()"
        onclick="hideddrivetip()"
        ';
    }
    return($tooltipText);
  }

  class CMSForm
  {
    var $formID;
    var $formTable;
    var $resultSet;
    var $dataSet;
    var $hiddenFields;
    var $fields;
    var $toolbarPosition;
    var $formLanguage;

    function CMSForm($id, $table = null, $keyvalue = null, $properties = array())
    {
      $this->formID = $id;
      $this->formTable = $table;
      $this->dataSetKey = $keyvalue;
      if ($keyvalue)
        $this->dataSet = DB_GetDataset($table, $keyvalue);
      $this->hiddenFields = array(
        'cmd' => 'saveform',
        'm' => $_REQUEST['m'],
        );
      $this->toolbarPosition = getDefault($properties['toolbarPosition'], 'top');
      if ($properties['nodatabase'] != true)
        $this->fields = $this->getFieldsFromDB($properties['specialfields']);
      $this->params = array(
        'm' => $_REQUEST['m'],
        'ignoreFormChange' => 'true');
      $this->formLanguage = getDefault($properties['language'], 'en');
    }

    function getFieldsFromDB($specialfields = null)
    {
      global $config;
      $items = array();

      if (is_array($specialfields))
        foreach ($specialfields as $sf) $items[] = $sf;

      global $currentSiteID;
      $result = DB_GetList('SELECT * FROM '.getTableName('blockfields').'
        WHERE bf_ref_block="'.$this->formID.'" AND (refSiteID="'.$currentSiteID.'"
        OR refSiteID="0")
        ORDER BY bf_order');

      if (sizeof($result)>0)
        foreach ($result as $item)
        {
          $item['bf_properties'] = stringListToArray($item['bf_properties']);
          $items[] = $item;
        }

      return($items);
    }

    function getField($databinding)
    {
      $segments = explode('/', $databinding);
      $result = $this->dataSet;
      foreach ($segments as $segment)
      {
        $result = $result[$segment];
      }
      return($result);
    }

    function setField(&$ds, $databinding, $value)
    {
      $segments = explode('/', $databinding);
      $path = '';
      foreach ($segments as $segment)
      {
        $path .= "['".$segment."']";
      }
      $path = '$ds'.$path.' = $value;';
      eval($path);
    }

    function getData()
    {
      $result = $_REQUEST['saveform'] == '#'.$this->formID;
      if ($result)
      {
        global $config;

        foreach ($_REQUEST as $k => $fieldType)
        {
          if (substr($k, 0, 4)=='fed_')
          {
            CutSegment('_', $k);
            $value = $_REQUEST['fld_'.$k];
            $saveHandler = 'interface/editors/'.$fieldType.'.save.php';
            $dontSave = false;
            if (file_exists($saveHandler))
            {
              $field['key'] = $k;
              $dontSave = false;
              include($saveHandler);
            }
            if (!$dontSave)
            {
              $this->setField($this->resultSet, $k, $value);
              $this->setField($this->dataSet, $k, $value);
            }
          }
        }

      }
      return($result);
    }

    function saveData()
    {
      if (isset($this->dataSet))
      {
        DB_UpdateDataset($this->formTable, $this->dataSet);
      }
    }

    function redirect($url)
    {
      @header('location: '.$url);
      print('<script>document.location="'.$url.'";</script>');
      exit;
    }

    function getLocalizedFields($rawfields)
    {
      global $currentPage;
      $fieldItems = array();
      $flagtxt = i18n('mci.languageflag');
      foreach ($rawfields as $item)
      {
        $item['bf_ofieldname'] = $item['bf_fieldname'];
        if ($item['bf_localized'] == 'Y')
        {
          $item['bf_fieldname'] =
            $item['bf_fieldname'].':'.$this->formLanguage;
          $item['clang'] = $this->formLanguage;
          $item['clangflag'] = '<img src="interface/img/ico_locale16.png" alt="'.$flagtxt.'"
            title="'.$flagtxt.'"
            align="absmiddle"/> '.$this->formLanguage;
        }
        $fieldItems[] = $item;
      }
      return($fieldItems);
    }

    function display()
    {
      global $config;

      $dataSet = $this->dataSet;
      $this->params['saveform'] = '#'.$this->formID;

      $fieldItems = $this->getLocalizedFields($this->fields);

      include('lib/cmsform.template.php');

      if (isset($firstEditField))
        print('<script>document.getElementById("fld_'.$firstEditField.'").focus();</script>');
    }

  }

?>
