<?
  /* File:    lib/cmstree.php: provides a set of functions to handle and display
   *          trees and sets of content nodes (support functions for ContentNode)
   * Type:    user interface / library
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    /
   * Changes: 06.04.2006, Marco - Added function getTreeArray
   */

  include_once('lib/cms.dropdownmenu.class.php');
  include_once('lib/alertboxes.php');

  // get a breadcrumb path array to the node $toItemKey
  function getTreePath($toItemKey)
  {
    global $config;
    $path = array();
    $parentRef = $toItemKey;
    // get the parent node as long as it isn't == 0 or root
    while ($parentRef != $config['siteds']['s_home_node'] && $parentRef!=0)
    {
      $ds = DB_GetDataset('pages', $parentRef);
      $path[] = $ds['p_key'];
      $parentRef = $ds['p_ref_parent'];
    }
    return(array_reverse($path));
  }

  // display a tree
  function displaySiteTree($parentNode, &$stateinfo, $level = 0, $indent = '&nbsp;')
  {
    global $config, $currentSiteID;
    if (!isset($stateinfo['path'])) $stateinfo['path'] = getTreePath($stateinfo['selnode']);
    $nextBranch = $stateinfo['path'][$level];

    if ($config['cms']['versioning'])
      $join_versions = ' LEFT JOIN '.getTableName('versioncontent').
        ' ON (c_ref_version = "'.ver_get_currentkey().'" AND c_ref_node = p_key) ';

    $lang = getDefault($_SESSION['editlanguage'], $_SESSION['currentlang']);
    $baseUrl = $_REQUEST;
    $query = 'SELECT * FROM '.getTableName('pages').
      $join_versions.
      ' WHERE p_ref_parent="'.$parentNode.'" AND p_ref_list="-1"
        AND '.getTableName('pages').'.refSiteID="'.$currentSiteID.'"
        ORDER BY p_order, p_caption';
    $list = DB_GetList($query);

    // print_r($query);
    // print('<br><br>');
    // print($currentSiteID);

    if (is_array($list))
      foreach ($list as $items)
      {
        $itemDS = $items;
        $pageInfo = unserialize($items['p_pageinfo']);
        $baseUrl['node'] = $items['p_key'];
         
        $folder = ''; $style = '';  $extra = '';
        $caption = getDefault($pageInfo['caption:'.$lang], $items['p_caption']);
        $itemstyle = ''; $itemhint = $caption;
        if (!($items['p_ref_version'] == 0 ||
          $items['p_ref_version'] == ver_get_currentkey()))
          continue;
        $itemActive = false;
        if ($stateinfo['selnode'] == $items['p_key'])
        {
          $style = 'entry-selected';
          $folder = '_blue';
          $itemActive = true;
          
          $ddmenu = new DropDownMenu();
          $ddmenu->addItem(i18n('mci.node.menu2'), '');
          $ddmenu->addItem(i18n('mci.node.addbelow'),
            '?m=admin/screen_content/show_tree&cmd=new&node='.$items['p_key']);
          if ($items['p_ref_parent'] == 0)
            $ddmenu->addItem(i18n('mci.node.addroot'),
              '?m=admin/screen_content/show_tree&cmd=newroot&node='.$items['p_key']);
          if ($items['p_key'] != $config['site']['home_node'])
            $ddmenu->addItem(i18n('mci.node.remove'),
              makeConfirmLink(
                '?m=admin/screen_content/show_tree&cmd=del&node='.$items['p_key'],
                i18n('mci.confirm.deletenode')));

          /*$extra = '<a '.$ddmenu->getEventCode().'>
              <img border="0" style="cursor: pointer; padding: 3px"
              src="interface/img/ico_options16.png"
              title="'.i18n('mci.hint.nodeoptions').'" alt="'.i18n('mci.hint.nodeoptions').'"/></a>'.
              $ddmenu->getDisplayCode();*/
          $extra .= '<img style="padding-top: 5px;" src="interface/img/btn_treenode_closed.gif"/>';
          
        }
        if ($items['c_key'] != 0)
        {
          $itemDS = unserialize($items['c_node']);
          $itemhint = $caption.': changed in current version ';
          $folder = '_green';
        }
        if ($items['c_status'] == 'D')
        {
          $itemstyle = 'color: red;';
          $itemhint = $caption.' (deleted)';
          $folder = '_red';
        }
        if ($items['p_ref_version'] != 0)
        {
          $itemhint = $caption.': new in current version ';
          $caption .= '*';
        }
        if ($items['p_status'] == 'H')
        {
          if ($itemActive)
            $itemstyle .= 'color: black;'; else $itemstyle .= 'color: gray;';
          $itemhint .= ' (hidden)';
        }
        $indentpx = $level * 16;
        print('<tr><td nowrap class="blockentry '.$style.'" ><div blockid="'.$block['guid'].'">
          <a title="'.$itemhint.'"
            style="padding-left: '.$indentpx.'px; '.$itemstyle.'" href="?'.array2Url($baseUrl).'">
            <img align="absmiddle" src="interface/img/folder'.$folder.'.png"/> '.
            getDefault($caption, i18n('mci.unnamed')).'&nbsp;</a></div></td>
            <td class="'.$style.'" align="right">'.$extra.'</td></tr>');
        if ($nextBranch == $items['p_key'])
          displaySiteTree($items['p_key'], $stateinfo, $level+1, $indent.'&nbsp;&nbsp;&nbsp;');
      }
  }

  
  function getTreeArray($basenode, &$options, $levelname)
  {
      //Returns recursive array structure of pages beginning from basenode
      //$options returns an array usable for select tags
      //      
      $nodeArray = array();
      
      $query = '
        SELECT p_key, p_ref_parent, p_caption
        FROM '.getTableName('pages').' 
        WHERE p_ref_parent = '.$basenode;
      $list = DB_GetList($query);
      
      foreach ($list as $page)
      {
          $add_option['id'] = $page['p_key'];
          $add_option['caption'] = $levelname.' - '.$page['p_caption'];
          $add_option['caption'] = substr($add_option['caption'], 3);
          $options[] = $add_option;
          
          $add['key'] = $page['p_key'];
          $add['caption'] = $page['p_caption'];
          $add['subs'] = getTreeArray($page['p_key'], &$options, $levelname.' - '.$page['p_caption']);
          $nodeArray[] = $add;
      }
      
      return $nodeArray;
  }
  
?>
