<?php

  function getBlockTypes()
  {
    include_once('lib/fileutils.php');
    
    $result = array();
    $sqlLegacyBlocks = DB_GetList('SELECT * FROM '.getTableName('blocks'));
    if (sizeof($sqlLegacyBlocks)>0)
      foreach ($sqlLegacyBlocks as $sqlBlock)
      {
        $result[] = array(
          'id' => $sqlBlock['b_key'],        
          'caption' => $sqlBlock['b_caption'],        
          );
      }
      
    $fileBlocks = getFileList('interface/block_editors/', 
      array('hideextensions' => true)
      );
    if (sizeof($fileBlocks)>0)
      foreach ($fileBlocks as $fileBlock)
      {
        if (stristr($fileBlock['caption'], '.save')=='')
          $result[] = array(
            'id' => $fileBlock['caption'],
            'caption' => $fileBlock['caption']);
      }
      
    return($result);    
  }

  class ContentBlock
  {
    var $contentNode;
    var $data;
    var $guid;
    var $type;
    var $typeDS;
    var $fields;
    var $typeName;
    var $nameField;
    var $section;

    function ContentBlock(&$contentNode, $blockID)
    {
      $this->contentNode = &$contentNode;
      $blockArray = $contentNode->getBlockByGuid($blockID);
      $this->data = $blockArray;
      $this->guid = $this->data['guid'];
      $this->type = $blockArray['type'];
      $this->typeDS = DB_GetDataset('blocks', $blockArray['type']);
      $this->typeName = getDefault($this->typeDS['b_caption'], $blockArray['type']);
      $this->nameField = $this->typeDS['b_namebind'];
      $this->section = $this->data['section'];
    }

    function update($newBlockData)
    {
      $this->data = $newBlockData;

      // automatic naming
      if (stristr($this->nameField, '>')!='')
      {
        $parts = explode('>', $this->nameField);
        $pointer = $this->data[$parts[0]];
        $refTable = $parts[1];
        $refField = $parts[2];
        $refDS = DB_GetDataset($refTable, $pointer);
        $dynamicNameField = $refDS[$refField];
      }
      else
      {
        $dynamicNameField = getDefault(
          $this->data[$this->nameField.':'.$this->contentNode->currentLanguage],
          $this->data[$this->nameField]);
      }
      $this->data['internalname'] = getDefault(
        $dynamicNameField, $this->typeName);

      if ($this->data['section'] != $this->section)
      {
        print('section move to: '.$this->data['section']);
        $this->contentNode->deleteBlockByGuid($this->guid);
      }
      $this->contentNode->setBlockByGuid($this->guid, $this->data);
      $this->contentNode->save();
    }


  }

?>
