<?php

/* File:    databasephp: the central database layer of the CMS
 * Type:    CMS function library
 * Author:  udo.schroeter@gmail.com
 * License: commercially licensed as part of the CMS package
 * Todo:    /
 * Changes: -
 */

$DB_HOST = $config['db']['host'];
$DB_USER = $config['db']['user'];
$DB_PASS = $config['db']['password'];
$DB_NAME = $config['db']['database'];

$SUPPORTS_XDATA = false;

$DBERR = '';

function getTableName($table)
{
  checkTableName($table);
  return($table);
}

function checkTableName(&$table)
{
  global $config;
  $l = strlen($config['db']['prefix']);
  if (substr($table, 0, $l) != $config['db']['prefix'])
    $table = $config['db']['prefix'].$table;
  return($table);
}

function getSQLDateTime($unixTimeStamp)
{
  return(date('Y-m-d H:i:s', $unixTimeStamp));
}

function DB_ProfileCall($txt)
{
  global $request_id;
}

DB_ProfileCall($_SERVER['QUERY_STRING']);

// create a comma-separated list of keys in $ds
function MakeNamesList(&$ds)
{
  $result = '';
  foreach ($ds as $k => $v)
  {
    if ($k!='')
      $result = $result.','.$k;
  }
  return substr($result, 1);
}

// make a name-value list for UPDATE-queries
function MakeValuesList(&$ds)
{
  $result = '';
  global $db_link;
  foreach ($ds as $k => $v)
  {
    if ($k!='')
      $result = $result.',"'.mysql_real_escape_string($v, $db_link).'"';
  }
  return substr($result,1);
}

function DB_GetTableMetaData($tablename)
{
  //DB_ProfileCall('TABLE METADATA '.$tablename);
  checkTableName($tablename);
  $ds = DB_GetDataset('sys_schema', 'TABLEMETA/'.$tablename);
  $meta = unserialize($ds['sc_data']);
  return($meta);
}

// retrieves a list of fields and their metadata for the give table
function DB_ListFields($tablename, $simple = false, $clearXdata = true,
  $withMetaData = false, $withKeys = false)
{
  //DB_ProfileCall('LIST FIELDS '.$tablename);
  checkTableName($tablename);
  include('lib/database-db_listfields.tx');
  return($fieldDesc);
}

// gets a list of keys for the table
function DB_GetKeys($tablename)
{
  global $config, $db_link;
  checkTableName($tablename);
  if ($db_link != null)
  {
    if (!isset($config['dbkeytmp'][$tablename]))
    {
      //DB_ProfileCall('GET KEYS '.$tablename);
      $pk = Array();
      $sql = 'SHOW KEYS FROM `'.$tablename.'`';
      $res = mysql_query($sql, $db_link);
      while ($row = @mysql_fetch_assoc($res))
      {
        if ($row['Key_name']=='PRIMARY')
          array_push($pk, $row['Column_name']);
      }
      $config['dbkeytmp'][$tablename] = $pk;
    }
    else
    {
      $pk = $config['dbkeytmp'][$tablename];
    }
  }
  return $pk;
}

// removes extended data from dataset and puts it into the $result
function DB_ExtractExtData(&$dataset, &$puredata, &$extdata)
{
  $puredata = array();
  $extdata = array();

  foreach ($dataset as $k => $v)
    if ($k != '')
    {
      if (substr($k, 0, 1)=='^')
      {
        $extdata[$k] = $v;
      }
      else
      {
        $puredata[$k] = $v;
        $extdata['^'.$k] = $v;
      }
    }
}

function DB_UnpackExtData(&$dataset)
{
  $xdata = unserialize($dataset['_xdata']);
  if (!is_array($xdata)) $xdata = array();
  foreach ($xdata as $k => $v)
  {
    if (substr($k, 0, 1)!='^')
      $dataset[$k] = $v;
  }
  unset($dataset['_xdata']);
}

// updates/creates the $dataset in the $tablename
function DB_UpdateDataset($tablename, &$dataset)
{
  //DB_ProfileCall('UPDATE '.$tablename);
  checkTableName($tablename);
  $keynames = DB_GetKeys($tablename);
  $keyname = $keynames[0];
  global $db_link, $config, $DBERR;

  if ($dataset['refSiteID'] == 0 && $tablename != getTableName('sites'))
    $dataset['refSiteID'] = $config['site']['dsid'];

  if (substr($tablename,0,4) != 'sys_' && $SUPPORTS_XDATA)
  {
    DB_ExtractExtData($dataset, $pureData, $extendedData);
    $pureData['_xdata'] = serialize($extendedData);
  }
  else
  {
    $pureData = $dataset;
  }

  $query='REPLACE INTO '.$tablename.' ('.MakeNamesList($pureData).
      ') VALUES('.MakeValuesList($pureData).');';

  mysql_query($query, $db_link) or $DBERR = (mysql_error().'{ '.$query.' }');
  if (trim($DBERR)!='') logToFile('log/err.sql.log', $DBERR);
  $dataset[$keyname] = getDefault($dataset[$keyname], mysql_insert_id($db_link));
  $pureData[$keyname] = $dataset[$keyname];
  return $pureData[$keyname];
}

// get all the tables in the current database
function DB_GetTables($simple = true,$DB_NAME)
{
  //DB_ProfileCall('LIST TABLES');
  include('lib/database-db_gettables.tx');
  return($tableList);
}

// from table $tablename, get dataset with key $keyvalue
function DB_GetDataSet($tablename, $keyvalue, $keyname = null)
{
  global $db_link, $config, $DBERR;
  if (!$db_link) return(array());
  if (!isset($config['dbtmp'][$tablename][$keyname.'.'.$keyvalue]))
  {
    $result = array();
    if ($keyvalue != '' && $keyvalue != '0')
    {
      //DB_ProfileCall('GET DATASET '.$tablename.' '.$keyvalue);
      checkTableName($tablename);
      if ($keyname == null)
      {
        $keynames = DB_GetKeys($tablename);
        $keyname = $keynames[0];
      }

      $rs = mysql_query('SELECT * FROM '.$tablename.' WHERE '.$keyname.'="'.
        mysql_escape_string($keyvalue).'";', $db_link)
        or $DBERR = mysql_error($db_link).'{ '.$query.' }';

      if ($line = @mysql_fetch_array($rs, MYSQL_ASSOC))
      {
        $result = $line;
        DB_UnpackExtData($result);
        mysql_free_result($rs);
      }
      else
        $result = array();
    }
    $config['dbtmp'][$tablename][$keyname.'.'.$keyvalue] = $result;
  }
  else
  {
    $result = $config['dbtmp'][$tablename][$keyname.'.'.$keyvalue];
  }
  return $result;
}

function DB_RemoveDataset($tablename, $keyvalue, $keyname = null)
{
  //DB_ProfileCall('REMOVE DATASET '.$tablename.' '.$keyvalue);
  global $db_link, $DBERR;
  checkTableName($tablename);
  if ($keyname == null)
  {
    $keynames = DB_GetKeys($tablename);
    $keyname = $keynames[0];
  }

  $rs = mysql_query('DELETE FROM '.$tablename.' WHERE '.$keyname.'="'.
  mysql_real_escape_string($keyvalue, $db_link).'";', $db_link)
    or $DBERR = mysql_error($db_link).'{ '.$query.' }';
}

// retrieve dataset identified by SQL $query
function DB_GetDataSetWQuery($query)
{
  //DB_ProfileCall('QUERY '.$query);
  global $DBTID, $db_link, $DBERR;

  $rs = mysql_query($query, $db_link)
    or $DBERR = mysql_error($db_link).'{ '.$query.' }';

  if ($line = mysql_fetch_array($rs, MYSQL_ASSOC))
    {
    $result = $line;
    DB_UnpackExtData($result);
    mysql_free_result($rs);
  }
  else
  $result = array();
  return $result;
}

// execute a simple update $query
function DB_Update($query)
{
  //DB_ProfileCall('UPDATE '.$query);
  global $db_link, $DBERR;
  $query = trim($query);
  if (substr($query, -1, 1) == ';')
    $query = substr($query, 0, -1);
  $rs = mysql_query($query)
    or $DBERR = mysql_error().'{ '.$query.' }';
}

// get a list of datasets matching the $query
function DB_GetList($query, $clearXdata = true, $keyByField = null)
{
  //DB_ProfileCall('GET LIST '.$query);
  global $config, $db_link, $DBERR;
  $result = array();

  if ($config['db']['notconfigured'] == true) return(array());

  $lines = mysql_query($query, $db_link) or $error = mysql_error($db_link).'{ '.$query.' }';

  if (trim($error) != '')
  {
    $DBERR = $error;
    logToFile('log/err.sql.log', $error);
  }
  else
  {
    while ($line = mysql_fetch_array($lines, MYSQL_ASSOC))
    {
      if ($clearXdata) unset($line['_xdata']);
      if (isset($keyByField))
        $result[$line[$keyByField]] = $line;
      else
        $result[] = $line;
    }
    mysql_free_result($lines);
  }
  return $result;
}

function DB_GetSignatureFields($table)
{
  $tableInfo = DB_GetTableMetaData($table);
  return($tableInfo['signature']);
}

function makeSignatureContent($table, $key)
{
  $ds = DB_GetDataset($table, $key);
  $siglist = DB_GetSignatureFields($table);
  foreach ($siglist as $sig)
  {
    if (sizeof($content)==1) $content[] = '-';
    $content[] = $ds[$sig];
  }
  return(implode(' ', $content));
}

// ***************************************************************************
// include settings from database
// ***************************************************************************

profiler_log('db: parse complete');

$db_link = @mysql_pconnect($DB_HOST, $DB_USER, $DB_PASS) or
  $DBERR = 'The database connection to server '.$DB_USER.'@'.$DB_HOST.' could not be established (code: '.@mysql_error($db_link).')';

@mysql_select_db($DB_NAME, $db_link) or
  $DBERR = 'The database connection to database '.$DB_NAME.' on '.$DB_USER.'@'.$DB_HOST.' could not be established. (code: '.@mysql_error($db_link).')';

if ($DBERR != '')
{
  $errorMessage = $DBERR;
  $config['db']['notconfigured'] = true;
  if (file_exists('etc/config.db.php'))
  {
    if ($_REQUEST['m'] != 'setup') print($errorMessage);
    logToFile('log/err.sql.log', $DBERR);
  }
}
else
{
  $config['db']['connected'] = true;
}
profiler_log('db: connection ready');

?>
