<?php
  /* File:    lib/fileutils.php: functions for manipulating files
   * Type:    CMS function library
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    /
   * Changes: -
   */

  function ForceDirectories($dirpath)
  {
    $segs = explode('/', $dirpath);
    $p = '';
    foreach ($segs as $seg)
    {
      $p .= $seg.'/';
      if (!is_dir($p))
        mkdir($p);
    }
  }

  function makeSafeFileName($raw)
  {
    $result = '';
    $raw = strtolower($raw);
    for ($a = 0; $a < strlen($raw); $a++)
    {
      $c = $raw[$a];
      $o = ord($c);
      if ($o >= ord('a') && $o <= ord('z') || $c == '.' || $c == '_')
        $result .= $c;
    }
    return($result);
  }

  function makeUniqueFilename($path, $filename, $extension)
  {
    while (file_exists($path.$filename.$nr.'.'.$extension))
    {
      if ($nr == 0) $nr = 2; else $nr++;
    }
    return($filename.$nr.'.'.$extension);
  }

  function getNewFileName($fnstart, $fnend)
  {
    while (file_exists($fnstart.($ctr+1).$fnend))
    {
      $ctr++;
    }
    return($fnstart.($ctr+1).$fnend);
  }

  function getFileList($path, $options = array())
  {
    $result = array();
    $match = $options['match'];
    if (file_exists($path))
    {
      if ($handle = opendir($path))
        while (false !== ($file = readdir($handle)))
        {
        $isDirectory = is_dir($path.$file);
        if (substr($file,0,1)!='.' &&
          ((!$getDirectories && !$isDirectory) || ($getDirectories && $isDirectory)))
        {
          $filecapt = $file;
          if ($options['hidefirstpart']) CutSegment('.', $filecapt);
          if ($options['replacecapt']) $filecapt = str_replace($options['replacecapt'][0], $options['replacecapt'][1], $filecapt);
          if ($options['hideextensions']) $filecapt = substr($filecapt, 0, -4);
          if ($options['removeextensions']) $file = substr($file, 0, -4);
          if ($options['defaultcaption']) $filecapt = getDefault($filecapt, $options['defaultcaption']);
          if ($match == null || preg_match($match, $file)>0)
            $result[] = array('id'=>$file, 'caption'=>$filecapt);
        }
      }
      @closedir($handle);
      sort($result);
    }
    return($result);
  }

  function getDirList($path, $options = array())
  {
    $result = array();
    if (file_exists($path))
    {
      if ($handle = opendir($path))
        while (false !== ($file = readdir($handle)))
        {
          $isDirectory = is_dir($path.$file);
          if ($isDirectory && substr($file,0,1)!='.') 
            $result[] = array('id' => $file, 'caption' => $file);          
        }
      @closedir($handle);
      sort($result);
    }
    return($result);
  }

  function deleteThemAll($path,$prefix)
    {
    //Deletes files and dirs from given path recursively
    $files = getFileList($path);
    foreach ($files as $file)
      {
      if (is_dir($path."/".$file['caption']))
        {
        deleteThemAll($path."/".$file['caption'],$prefix);
        }
      else
        {
        if ($_REQUEST['killfilesinuse']=="")
          {
          $query = "SELECT * from ".$prefix."pages WHERE p_content LIKE '%".substr($path."/".$file['caption'],strpos($path."/".$file['caption'], "/")+1)."%';";
          $result = DB_GetList($query);
          $rows = sizeof($result);
          if ($rows > 0)
            {
            ?>
            <script language="javaScript">
            <!--
              if (confirm("<?= i18n('mci.delResourceInUse') ?>"))
                {
                window.location.href="?m=admin&i=deleteResource&currentResourceFolder=<?= $_REQUEST['currentResourceFolder'] ?>&file=<?= $_REQUEST['file'] ?>&killfilesinuse=yes";
                }
              else
                {
                window.location.href="?m=admin&i=resources&currentResourceFolder=<?= $_REQUEST['currentResourceFolder'] ?>";
                }  
            //-->
            </script>
            <?
            }
          }    
        else      
          unlink($path."/".$file['caption']);  
        }
      }
    rmdir($path);  
    }

?>
