<?
  /* File:    lib/parsetext.php: text parsing functions
   * Type:    CMS function library
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    - 
   * Changes: - imported parseContentText() from lib/genlib.tx
   */
  function getLinkTarget(&$paramkeys, $linkurl = null)
  {
    if ($linkurl != null) $paramkeys['link'] = $linkurl;
    if (!isset($paramkeys['target']))
    {
      if (strstr($paramkeys['link'], 'http://')!='')
        $paramkeys['target'] = '_blank';
      else
        $paramkeys['target'] = '_self';
    }
  }
  
  // parse cleartext for CITE-Commands
  function parseContentText($raw)
  {
    $result = '';
    
    while ($raw != '')
    {
      $result .= CutSegmentEx('(+', $raw, $found);
      if ($found)
      {
        $command = CutSegment(')', $raw);
        $keyword = CutSegment(':', $command);
        $parameters = explode(';', $command);       
        $paramkeys = array();
        foreach ($parameters as $p)
        {
          $key = CutSegment('=', $p);
          $paramkeys[trim($key)] = trim($p);
        }
        
        // todo: maybe we could have custom functions in here for the future?
        switch ($keyword)
        {
          case('link'):
          {
            getLinkTarget($paramkeys, trim($parameters[0]));
            $result .= '<a href="'.trim($parameters[0]).'" target="'.$paramkeys['target'].'">'.
              trim($parameters[1]).'</a>';       
            break;
          }
          case ('emphasis'):
          {
            $result .= '<em>'.$command.'</em>';
            break;
          } 
          case ('image'):
          {
            getLinkTarget($paramkeys);
            $img = '<img src="'.trim($parameters[0]).'" border="0" align="'.$paramkeys['align'].'"/>';
            if (isset($paramkeys['link']))
              $img = '<a href="'.$paramkeys['link'].'" target="'.$paramkeys['target'].'">'.$img.'</a>';
            $result .= $img;
            break;
          } 
          default:
          {
            $result .= '<span style="color: gray">(+'.$keyword.': '.$command.')</span>';
            break;
          }
        }
      }
    }
    
    return($result);
  }


?>