<?php
/* File:    applies template datasets (with refSiteID = "0") to the current site
 * Type:    CMS function library
 * Author:  udo.schroeter@gmail.com
 * License: commercially licensed as part of the CMS package
 * Todo:    /
 * Changes: -
 */

 function updateTable($tablename, $newSiteID)
 {
   $DSList = DB_GetList('SELECT * FROM '.getTableName($tablename).' WHERE
     refSiteID="0"');
   $keys = DB_GetKeys($tablename);
   $primary_key = $keys[0];
   foreach ($DSList as $DSItem)
   {
     $DSItem['refSiteID'] = $newSiteID;
     //print('<div>unsetting '.getTableName($tablename).':'.$primary_key.'</div>');
     //print_r($DSItem);
     unset($DSItem[$primary_key]);
     DB_UpdateDataset(getTableName($tablename), $DSItem);
   }
 }

 function removeSiteFromTable($tablename, $oldSiteID)
 {
   DB_Update('DELETE FROM '.getTableName($tablename).' WHERE
     refSiteID="'.$oldSiteID.'"');
 }

 function removeSite($oldSiteID)
 {
   $tables = DB_GetTables(true,$DB_NAME);
   foreach ($tables as $table)
   {
     removeSiteFromTable($table, $oldSiteID);
   }
 }

 function addSite($newSiteID)
 {
   $siteDS = DB_GetDataset('sites', $newSiteID);
   if (sizeof($siteDS)>0)
   {
     print('Site #'.$newSiteID.' already exists!');
   }
   else
   {
     $tables = DB_GetTables(true,$DB_NAME);
     foreach ($tables as $table)
     {
       updateTable($table, $newSiteID);
     }
   }
 }
 
 function importSite($siteId, $rootNode, $templateXML, $userDS)
 {
   include_once('lib/fileutils.php');
   print('importing to site#'.$siteId.' / rootnode='.$rootNode.'<br>');
   include_once('lib/xml2array.php');
   $import = Xml2Array($templateXML);
   $pagesBranch = &$import['site'][0]['pages'][0]['page'];
   print('Importing a total of '.sizeof($pagesBranch).' pages.<br>');
   foreach ($pagesBranch as $pageItem)
   {
     $ds = unserialize(urldecode(trim($pageItem['ds'][0]['$'])));
     $tmpKey = $ds['p_key'];
     unset($ds['p_key']);
     if (!isset($firstRoot) && $ds['p_ref_parent']==0)
     {
       // if this is the first root node to be imported, we need to replace the current one
       $ds['p_key'] = $rootNode;
       $firstRoot = $rootNode;
     }
     $ds['refSiteID'] = $siteId;
     $ds['p_site'] = $siteId;
     $ds['p_ref_owner'] = $userDS['us_key'];
     $newDSId = DB_UpdateDataset('pages', $ds);
     $pagesList[$tmpKey] = array(
       'parent' => $ds['p_ref_parent'],
       'newid' => $newDSId,
       );
   }
   $settingsBranch = &$import['site'][0]['settings'][0]['setting'];
   print('Importing a total of '.sizeof($settingsBranch).' settings.<br>');
   foreach ($settingsBranch as $settingItem)
   {
     $ds = unserialize(urldecode(trim($settingItem['ds'][0]['$'])));
     $tmpListKey = $ds['s_key'];
     unset($ds['s_key']);
     $ds['refSiteID'] = $siteId;
     $newSettingId = DB_UpdateDataset('settings', $ds);
     $listList[$tmpListKey] = $newSettingId;
   }
   print_r($listList);
   foreach ($pagesList as $k => $v)
   {
     $ds = DB_GetDataset('pages', $v['newid']);
     $parentPtr = $pagesList[$v['parent']]['newid'];
     $ds['p_ref_parent'] = $parentPtr;
     if ($ds['p_ref_list'] != -1) $ds['p_ref_list'] = $listList[$ds['p_ref_list']];
     $blockSections = unserialize($ds['p_content']);
     $newSections = array();
     foreach ($blockSections as $secKey => $secBlocks)
     {
       foreach ($secBlocks as $blockKey => $block)
       {
         if ($block['type'] == 'list')
         {
           $block['instance'] = $listList[$block['instance']];
         }
         if ($block['type'] == 'image')
         {
           $fle = $block['imgfile'];
           $oldFileName = $fle['filename'];
           $resPath = 'resource/'.$fle['type'];
           $fname = $fle['name'];
           $resFN = $ds['p_key'].'.'.$blockKey.'.'.makeSafeFileName($fname);
           $fle['resourcepath'] = $resPath;
           $fle['filename'] = $resPath.'/'.$resFN;
           $fle['timestamp'] = time();
           ForceDirectories($resPath);
           copy($oldFileName, $fle['filename']);
           $block['imgfile'] = $fle;
         }
         $newSections[$secKey][$blockKey] = $block;
       }
     }
     $ds['p_content'] = serialize($newSections);
     DB_UpdateDataset('pages', $ds);
   }
 }

 function createNewSite($caption, $sitename, $userDS)
 {
   $nodeDS = array(
     'p_ref_parent' => 0,
     'p_caption' => i18n('mci.unnamed'),
     );
   $home_node = DB_UpdateDataset('pages', $nodeDS);
   $siteDS = array(
     's_name' => $caption,
     's_subdirectory' => $sitename,
     's_active' => 'Y',
     's_home_node' => $home_node,
     );
   $site_id = DB_UpdateDataset('sites', $siteDS);
   $nodeDS['p_site'] = $site_id;
   $nodeDS['refSiteID'] = $site_id;
   DB_UpdateDataset('pages', $nodeDS);
   updateTable('annotations', $site_id);
   //updateTable('settings', $site_id);
   //updateTable('blockfields', $site_id);
   //updateTable('blocks', $site_id);
   updateTable('versions', $site_id);
   
   mkdir('sites/'.$sitename);
   mkdir('sites/'.$sitename.'/admin');
   WriteToFile('sites/'.$sitename.'/index.php', 
     str_replace('%sitename%', $sitename,
       implode("", file('etc/subsite.index.template.php')))
     );
   WriteToFile('sites/'.$sitename.'/admin/index.php', 
     str_replace('%username%', $userDS['us_username'],
       implode("", file('etc/subsite.admin-index.template.php')))
     );
   
   importSite($site_id, $home_node,
     implode('', file('etc/newsite.template.xml')),
     $userDS
     );
   
   return($site_id);
 }

 function deactivateSite($dsid)
 {
   $siteDS = DB_GetDataset('sites', $dsid);
   $siteDS['s_active'] = 'D';
   DB_UpdateDataset('sites', $siteDS);
 }

?>
