<?
  /* File:    lib/versioning.php: will handle versioning and workflow
   *
   * Type:    CMS class library
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    /
   * Changes: /
   */

   function ver_set_currentkey($key)
   {
     $_SESSION['cms']['versionkey'] = $key;
   }

   function ver_get_currentkey()
   {
     if (!isset($_SESSION['cms']['versionkey']))
     {
       // try to retrieve the latest version
       $versionkeyDS = DB_GetDatasetWQuery('SELECT v_key FROM
         '.getTableName('versions').' WHERE
         v_ref_user = "'.$_SESSION['cmsuser']['us_key'].'"
         ORDER BY v_stamp DESC');
       $versionkey = $versionkeyDS['v_key'];
     }
     else
       $versionkey = $_SESSION['cms']['versionkey'];
     return($versionkey);
   }

   function ver_get_version($createIfNotExists = false)
   {
     $version = DB_GetDataset('versions', ver_get_currentkey());
     if (sizeof($version)==0)
     {
       $version = array(
         'v_ref_user' => $_SESSION['cmsuser']['us_key'],
         );
       ver_set_currentkey(DB_UpdateDataset('versions', $version));
       $version = DB_GetDataset('versions', ver_get_currentkey());
     }
     return($version);
   }

   function ver_get_list()
   {
     global $currentSiteID;
     $vlist = DB_GetList('SELECT * FROM '.getTableName(versions).'
       WHERE v_ref_user="'.$_SESSION['cmsuser']['us_key'].'"
       AND refSiteID="'.$currentSiteID.'"
       ORDER BY v_stamp DESC');
     return($vlist);
   }

   function ver_display_gizmo()
   {
     include_once('lib/conversion.php');
     global $config, $site;
     $result = '';
     if ($config['cms']['versioning'])
     {
       $versionlist = ver_get_list();
       $version = ver_get_version(true);
       $stamp = DissectTimeStamp($version['v_stamp']);
       $hint = i18n('mci.versiongizmo.hint').' '.$stamp;
       $ddmenu = new DropDownMenu();
       $ddmenu->addItem('Edit', '');
       $ddmenu->addItem(i18n('mci.version.close'), '?m=admin/screen_content/show_tree&cmd=ver_close&node='.$_REQUEST['node']);
       $ddmenu->addItem(i18n('mci.version.edit'),
         'javascript:window.parent.document.location=\'?m=admin&i=startpage&listselect=none&node='.
         $_REQUEST['node'].'&view='.
         urlencode('?m=admin/screen_overview/edit_version').'\'');
       /*
       $ddmenu->addItem('Switch to', '');
       if (sizeof($versionlist)>0)
         foreach ($versionlist as $item)
           if ($version['v_key'] != $item['v_key'])
             $ddmenu->addItem(DissectTimeStamp($item['v_stamp']),
               '?m=admin/screen_content/show_tree&cmd=ver_switch&ver='.$item['v_key'].'&node='.$_REQUEST['node']);
       */
       $ddmenu->addItem(i18n('mci.version.new'), '?m=admin/screen_content/show_tree&cmd=ver_new&node='.$_REQUEST['node']);
       $result = '
         <img src="interface/img/ico_version16.png" style="cursor: pointer"
           align="absmiddle" '.$ddmenu->getEventCode().'/> Version: '.$stamp.
           $ddmenu->getDisplayCode();
     }
     return(getDefault($result, getDefault(
       $site->siteName, i18n('mci.website'))));
   }

?>
