<?
  /* File:    provides versioning services for the contentnode.class
   * Type:    CMS class library
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    -
   * Changes: /
   */

  /**
  * The VersioningStorage class is an augment to the ContentNode class.
  * Its job is to intermediate data retrieval and storage when versioning
  * is being used, so data from and to the pages tables gets rerouted through
  * the versioncontent table as appropriate.
  */
  class VersioningStorage
  {
    /**
    * Creates a new version node object

    * @nodenr	integer	node number of the content node
    */
    function VersioningStorage()
    {

    }
    
    function getVersionNode($nodenr, $versionid)
    {
      return(DB_GetDatasetWQuery(
        'SELECT * FROM '.getTableName('versioncontent').
        ' WHERE c_ref_node="'.$nodenr.'" AND c_ref_version="'.$versionid.'"'
        ));
    }
    
    function fillVersionDS(&$vnodeDS, $nodeDS, $versionKey)
    {
      // set the node reference
      $vnodeDS['c_ref_node'] = $nodeDS['p_key'];
      // set the version id reference
      $vnodeDS['c_ref_version'] = $versionKey;
      // set status to 'updated'
      $vnodeDS['c_status'] = 'U';    
      // serialize the content of the node
      $vnodeDS['c_node'] = serialize($nodeDS);
    }

    function save($nodeDS)
    {
      $isNewNode = $nodeDS['p_key'] == 0;
      $versionKey = ver_get_currentkey(true);

      if ($isNewNode)
      {
        // we need to save this preliminarily, first - to get a proper node id
        // set the status to hidden
        $nodeDS['p_status'] = 'H';
        // set the version reference to the current version number
        $nodeDS['p_ref_version'] = $versionKey;
        // do the update             
        $nodeDS['p_key'] = DB_UpdateDataset('pages', $nodeDS);
      }
      // retrieve any existing version first, to use the same dataset again
      $vnodeDS = $this->getVersionNode($nodeDS['p_key'], $versionKey);
      $this->fillVersionDS($vnodeDS, $nodeDS, $versionKey);
      // commit to database
      DB_UpdateDataset('versioncontent', $vnodeDS);
    }

    function load($nodekey)
    {
      $versionKey = ver_get_currentkey(true);
      $vnodeDS = $this->getVersionNode($nodekey, $versionKey);
       
      if (sizeof($vnodeDS)>0)
      {
        $this->vNodeDS = $vnodeDS;
        $resultDS = unserialize($vnodeDS['c_node']);
      }
      else
      {
        $resultDS = DB_GetDataset('pages', $nodekey);
      }
      return($resultDS);
    }

    function delete($nodeDS)
    {
      $versionKey = ver_get_currentkey(true);
      $vnodeDS = $this->getVersionNode($nodekey, $versionKey);
      if ($nodeDS['p_ref_version'] == $versionKey)
      {
        // this node was created in this version, so it's OK to delete it again
        DB_RemoveDataset('pages', $nodeDS['p_key']);
        DB_RemoveDataset('versioncontent', $vnodeDS['c_key']);
      }
      else
      {         
        $this->fillVersionDS($vnodeDS, $nodeDS, $versionKey);  
        $vnodeDS['c_status'] = 'D';
        DB_UpdateDataset('versioncontent', $vnodeDS);
        logToFile('log/delete.log', $vnodeDS);
      }
    }

  }

?>
