<?
  /* File:    this is the external RPC handler. Its
   *          purpose is to take any incoming XML request that was
   *          addressed to the ?m=admin/rpc URL. It doesn't do any processing
   *          in itself besides decoding the XML document into the $request
   *          variable and passing that on to whatever module was specified
   *          in the module attribute of the XML request item
   * Type:    handler
   * Author:  udo.schroeter@gmail.com
   * License: commercially licensed as part of the CMS package
   * Todo:    /
   * Changes: -
   */

  include_once('lib/genlib.tx');
  include_once('etc/config.php');
  include_once('lib/database.php');
  include_once('lib/citesite.class.php');
  include_once('lib/xml2array.php');

  $site = new CiteSite($subDomain, 's_subdirectory');

  $postData = getDefault($GLOBALS['HTTP_RAW_POST_DATA'], $_REQUEST['request']);
  if (get_magic_quotes_gpc()) $postData = stripslashes($postData);
  
  logToFile('log/rpc.log', $postData);
    
  $request = xml2array($postData);
  
  if (is_array($request['methodCall']))
  {                 
    $reqItem = $request['methodCall'][0];
    $reqItem['methodName'][0]['$'] = getDefault(
      $reqItem['methodName'][0]['$'], 'blogger.getUsersBlogs');
    $handler = 'interface/admin/rpc/'.$reqItem['methodName'][0]['$'].'.php';
    if (file_exists($handler))
      include($handler);
    else
    {
      logToFile('log/err.rpc.log', 'module not found: '.$handler);
      print('<?xml version="1.0"?>
      <methodResponse error="method not found: '.$reqItem['methodName'][0]['$'].'"></methodResponse>');
    }
  }
  else
    logToFile('log/err.rpc.log', 'Cannot read request:');

?>
